/**
 An Angular Builder to run xliffmerge.
 Work is based on nice blog article
 https://medium.com/dailyjs/angular-cli-6-under-the-hood-builders-demystified-f0690ebcf01 by Evgeny Barabanov
**/
import { Observable } from 'rxjs';
import { Builder, BuilderConfiguration, BuilderContext, BuildEvent } from '@angular-devkit/architect';
import { XliffmergeBuilderSchema } from './schema';
import { ProgramOptions, IConfigFile } from '@ngx-i18nsupport/ngx-i18nsupport';
export declare class XliffmergeBuilder implements Builder<XliffmergeBuilderSchema> {
    private context;
    constructor(context: BuilderContext);
    run(builderConfig: BuilderConfiguration<Partial<XliffmergeBuilderSchema>>): Observable<BuildEvent>;
    createProgramOptionsFromConfig(builderConfig: BuilderConfiguration<Partial<XliffmergeBuilderSchema>>): ProgramOptions;
    createProfileContentFromConfig(builderConfig: BuilderConfiguration<Partial<XliffmergeBuilderSchema>>): IConfigFile | undefined;
    private adjustPathToWorkspaceRoot;
}
export default XliffmergeBuilder;
