import { Swagger } from './odata2openapi';
import { Page } from './Page';
export interface Application {
    dataSources: Array<Swagger>;
    name: string;
    pages: Array<Page>;
    layouts: Array<Page>;
    navigation: Array<string>;
    theme: string;
    https: boolean;
    serverProject?: boolean;
    serverVersion?: string;
    serverLang?: string;
    port: number;
    serverPort: number;
    startPage: string;
    logo: string;
    security?: Security;
    localization?: Localization;
    ignore?: string[];
}
export interface Localization {
    defaultCulture: Culture;
    cultures: Array<Culture>;
}
export interface Culture {
    value: string;
    text: string;
}
export interface DefaultSecurity extends Security {
    provider: 'default';
    dataSource: string;
}
export interface ActiveDirectorySecurity extends Security {
    provider: 'active-directory';
    server: string;
    user: string;
    password: string;
}
export interface Security {
    provider: 'default' | 'active-directory';
    loginPage: string;
    roles?: string[];
}
export declare function isDefault(security: Security): security is DefaultSecurity;
export declare function isActiveDirectory(security: Security): security is ActiveDirectorySecurity;
