export interface BaseDeployOptions {
    source: string;
    server: string;
    user: string;
    password: string;
    onStart: (process: any) => void;
    onError: (err?: any) => void;
    onExit: () => void;
}
export interface DeployOptions extends BaseDeployOptions {
    provider: string;
    destination: string;
    connectionStrings: any;
    localization?: any;
    serverVersion?: string;
    method?: string;
    removeAdditional?: boolean;
    application?: any;
}
export declare function deployFTP({ source, server, user, password, onStart, onExit, onError }: BaseDeployOptions): void;
export declare function deployIIS({ source, provider, destination, server, user, password, method, connectionStrings, onStart, onExit, onError, removeAdditional }: DeployOptions): void;
export declare function deploy({ source, provider, destination, server, user, password, method, connectionStrings, localization, serverVersion, onStart, onExit, onError }: DeployOptions): void;
export interface MSDeployCommandOptions {
    options: string[];
    onStart: (process: any) => void;
    onError: (err?: any) => void;
    onExit: () => void;
}
export declare function executeMSDeployCommand({ options, onStart, onExit, onError }: MSDeployCommandOptions): void;
