declare const kebabCase: (string: any) => any;
import { Action } from './Event';
import { DataSource, Schema } from './DataSource';
import { Page } from './Page';
import { Application } from './Application';
export declare function isDotNet2({ serverVersion }: {
    serverVersion?: string;
}): boolean;
export declare function isAngularComponent(type: string): boolean;
export declare function isComponent(type: string): boolean;
export declare function componentTypes(layouts: Page[], pages: Page[]): string[];
export declare function inferComponentsFromTemplate(template: string): string[];
export declare function odataPrefix(dataSource: DataSource): string;
export declare function constant(value: string, suffix?: string): string;
export declare function validModel(model: Schema): boolean;
export declare function hasValue(type: string): boolean;
export declare function stringify(value: any): string;
export declare function renderComponent(component: any, application?: Application, options?: any): string;
export declare function type(value: string): string;
export declare function componentType(value: string): string;
export declare function pascalCase(value: string): string;
export declare function dotnetType(property: any, lang?: string): string;
export declare function isValidIdentifier(name: string): boolean;
export declare function dotnetPropertyName(name: string, enclosingType: string): string;
export declare function propertyName(name: string): string;
export declare function unwrapType(value: string): string;
export declare function indent(value: number | string, count?: number): string;
export declare function variable(value: string): string;
export { kebabCase as file };
export declare function comma(index: number, countOrArray: number | Array<any>): string;
export declare function primitive(type: string): boolean;
export declare function emitActions(application: Application, options: any, actions: Array<Action>, pageName: string, componentName: string, eventName: string, pages: Array<Page>, dataSources: Array<DataSource>, properties: Array<string>, spaces?: number): string;
export declare function emitAction(application: Application, options: any, action: Action, pageName: string, componentName: string, eventName: string, pages: Array<Page>, dataSources: Array<DataSource>, properties: Array<string>, spaces: any): string;
export declare function throwCodegenError(pageName: string, componentName: string, eventName: string, message: string): void;
export declare function interpolate(value: string, pageName: string, componentName: string, eventName: string): string;
export declare function interpolateAsCode(pageName: string, componentName: string, eventName: string, properties: Array<string>, expression?: string, quote?: boolean): string;
export declare function interpolateAsCodeForFilter(pageName: string, componentName: string, eventName: string, properties: Array<string>, expression?: string, quote?: boolean): string;
export declare function interpolateAsAttribute(properties: Array<string>, expression?: string): string;
export declare function parseExpression(value: string, pageName: string, componentName: string, eventName: string): {
    strings: any;
    values: any;
};
export declare function isBoundExpression(expression: string): boolean;
export declare function appendIfNotLast(str: string, index: number, countOrArray: number | Array<any>): string;
