import { Swagger } from './odata2openapi';
import { Page } from './Page';
import { Application } from './Application';
export * from './toolbox';
export * from './bootstrap';
export * from './build';
export * from './deploy';
export * from './securityDataSource';
export declare function styles(application: Application): Array<string>;
export declare function copyThemeDir(path: string, source: string, name: string, application: Application): Promise<any>;
export declare function customThemePath(): string;
export declare function copyAssets(path: string, source: string, application: Application): Promise<any>;
export declare function setConfigValue(path: string, key: string, value: string): Promise<any>;
export declare function getConfigValue(path: string, key: string, sync?: boolean): Promise<any> | string;
export declare function getConnectionString(path: string, key: string, sync?: boolean): string | Promise<any>;
export declare function setConnectionString(path: string, key: string, value: any): Promise<any>;
export declare function getDeployData(path: string, dataFile?: string): Promise<any>;
export declare function setDeployData(path: string, value: any, dataFile?: string): Promise<any>;
export declare function saveSSL(path: string, key: string, cert: string, pfx: string, application: Application): Promise<any>;
export declare function generate(path: string, application: Application, isRunning: boolean, mode: any, options: any): Promise<any>;
export interface StartServerOptions {
    directory: string;
    command: string;
    serverVersion: string;
    options: string;
    successMessage: string;
    onStart: (process: any) => void;
    onError: () => void;
    onExit: () => void;
    onSuccess: () => void;
}
export declare function startServer({ command, serverVersion, options, successMessage, directory, onStart, onError, onExit, onSuccess }: StartServerOptions): void;
export declare function supportsServer(): Promise<any>;
export declare function designTimeHtml(application: Application): Promise<string>;
export declare function setPageTitle(contentDocument: Document, title: string): void;
export declare function setLogo(contentDocument: Document, path: string, application: Application): void;
export declare function navigationContainerElement(contentDocument: Document): Element;
export declare function contentElements(contentDocument: Document): NodeListOf<Element>;
export declare function deleteDataSource(path: string, name: string, swagger: Swagger, application: Application): Promise<any>;
export declare function deletePage(path: string, name: string): Promise<any>;
export declare function renamePage(path: string, from: string, to: string): Promise<any>;
export declare function pageParameters(pages: Array<Page>): any;
