export declare function securityDataSource(): {
    swagger: string;
    info: {
        title: string;
        version: string;
    };
    produces: any[];
    host: any;
    schemes: string[];
    basePath: any;
    definitions: {
        Error: {
            type: string;
            properties: {
                error: {
                    type: string;
                    properties: {
                        message: {
                            type: string;
                        };
                    };
                };
            };
        };
        Role: {
            type: string;
            properties: {
                Id: {
                    type: string;
                    'x-key': boolean;
                };
                Name: {
                    type: string;
                };
            };
            required: string[];
        };
        User: {
            type: string;
            properties: {
                Id: {
                    type: string;
                    'x-key': boolean;
                };
                UserName: {
                    type: string;
                };
                Email: {
                    type: string;
                };
            };
            required: string[];
        };
    };
    paths: {
        '/auth/change-password': {
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                    required: boolean;
                }[];
                responses: {
                    204: {
                        description: string;
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        '/auth/login': {
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                    required: boolean;
                }[];
                responses: {
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        '/auth/reset-password': {
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                    required: boolean;
                }[];
                responses: {
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        '/auth/register': {
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                    required: boolean;
                }[];
                responses: {
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        '/auth/ApplicationUsers': {
            get: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                }[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            properties: {
                                value: {
                                    items: {
                                        $ref: string;
                                    };
                                    type: string;
                                };
                            };
                            type: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    schema: {
                        $ref: string;
                    };
                }[];
                responses: {
                    '201': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        "/auth/ApplicationUsers('{Id}')": {
            delete: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                }[];
                responses: {
                    '204': {
                        description: string;
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            get: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                }[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            patch: {
                operationId: string;
                parameters: ({
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                    schema?: undefined;
                } | {
                    in: string;
                    name: string;
                    required: boolean;
                    schema: {
                        $ref: string;
                    };
                    type?: undefined;
                })[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    '204': {
                        description: string;
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        "/auth/ApplicationRoles('{id}')": {
            delete: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                }[];
                responses: {
                    '204': {
                        description: string;
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            get: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                }[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            patch: {
                operationId: string;
                parameters: ({
                    in: string;
                    name: string;
                    required: boolean;
                    type: string;
                    schema?: undefined;
                } | {
                    in: string;
                    name: string;
                    required: boolean;
                    schema: {
                        $ref: string;
                    };
                    type?: undefined;
                })[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    '204': {
                        description: string;
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
        '/auth/ApplicationRoles': {
            get: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    type: string;
                }[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            properties: {
                                value: {
                                    items: {
                                        $ref: string;
                                    };
                                    type: string;
                                };
                            };
                            type: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
            post: {
                operationId: string;
                parameters: {
                    in: string;
                    name: string;
                    required: boolean;
                    schema: {
                        $ref: string;
                    };
                }[];
                responses: {
                    '201': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    default: {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                };
            };
        };
    };
};
