"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var transition_1 = require("./transition");
var layout_1 = require("./layout");
var BodyComponent = /** @class */ (function () {
    function BodyComponent(elementRef, layoutService) {
        var _this = this;
        this.elementRef = elementRef;
        this.style = {};
        this.ngUnsubscribe = new rxjs_1.Subject();
        layoutService.headerHeight.pipe(operators_1.takeUntil(this.ngUnsubscribe))
            .subscribe(function (headerHeight) {
            _this.headerHeight = headerHeight;
        });
        layoutService.footerHeight.pipe(operators_1.takeUntil(this.ngUnsubscribe))
            .subscribe(function (footerHeight) {
            _this.footerHeight = footerHeight;
        });
    }
    BodyComponent.prototype.ngAfterViewInit = function () {
        //Force redraw in WebKit browsers
        var nativeElement = this.elementRef.nativeElement;
        nativeElement.style.display = 'none';
        nativeElement.offsetHeight;
        nativeElement.style.display = '';
    };
    BodyComponent.prototype.ngOnDestroy = function () {
        this.ngUnsubscribe.next();
        this.ngUnsubscribe.complete();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], BodyComponent.prototype, "style", void 0);
    __decorate([
        core_1.ViewChild(layout_1.OffsetBySidebarDirective),
        __metadata("design:type", layout_1.OffsetBySidebarDirective)
    ], BodyComponent.prototype, "offset", void 0);
    BodyComponent = __decorate([
        core_1.Component({
            selector: 'rz-body',
            template: "\n  <div class=\"body\" [ngStyle]=\"style\" [style.marginTop.px]=\"headerHeight\" [style.marginBottom.px]=\"footerHeight\"\n      [@open]=\"{value: offset.sidebarOpen ? 'visible': 'hidden', params: {marginLeft: offset.sidebarWidth}}\"\n      [rz-offset-by-sidebar]=\"true\">\n    <ng-content></ng-content>\n  </div>\n  ",
            animations: [transition_1.sidebarAnimation]
        }),
        __metadata("design:paramtypes", [core_1.ElementRef, layout_1.LayoutService])
    ], BodyComponent);
    return BodyComponent;
}());
exports.BodyComponent = BodyComponent;
var BodyModule = /** @class */ (function () {
    function BodyModule() {
    }
    BodyModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, layout_1.LayoutModule],
            declarations: [BodyComponent],
            exports: [BodyComponent]
        })
    ], BodyModule);
    return BodyModule;
}());
exports.BodyModule = BodyModule;
