"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var document_token_1 = require("./document.token");
var content_1 = require("./content");
var ContentContainerComponent = /** @class */ (function () {
    function ContentContainerComponent(containerRef, contentService, documentToken) {
        var _this = this;
        this.containerRef = containerRef;
        this.contentService = contentService;
        this.documentToken = documentToken;
        this.subscription = contentService
            .afterContentRegistered()
            .subscribe(function (content) {
            if (_this.documentToken == null) {
                if (content.container == _this.name) {
                    var nativeElement = _this.containerRef.element.nativeElement;
                    var firstChild = nativeElement.firstChild;
                    if (firstChild) {
                        nativeElement.replaceChild(content.elementRef.nativeElement, nativeElement.firstChild);
                    }
                    else {
                        nativeElement.appendChild(content.elementRef.nativeElement);
                    }
                }
            }
        });
    }
    ContentContainerComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ContentContainerComponent.prototype, "name", void 0);
    ContentContainerComponent = __decorate([
        core_1.Component({
            selector: 'rz-content-container',
            template: "\n    <ng-content></ng-content>\n  "
        }),
        __param(2, core_1.Optional()),
        __param(2, core_1.Inject(document_token_1.DOCUMENT_TOKEN)),
        __metadata("design:paramtypes", [core_1.ViewContainerRef,
            content_1.ContentService, Object])
    ], ContentContainerComponent);
    return ContentContainerComponent;
}());
exports.ContentContainerComponent = ContentContainerComponent;
var ContentContainerModule = /** @class */ (function () {
    function ContentContainerModule() {
    }
    ContentContainerModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, content_1.ContentModule],
            declarations: [ContentContainerComponent],
            exports: [ContentContainerComponent]
        })
    ], ContentContainerModule);
    return ContentContainerModule;
}());
exports.ContentContainerModule = ContentContainerModule;
