"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var datalist_1 = require("primeng/datalist");
var datagrid_1 = require("primeng/datagrid");
var template_form_1 = require("./template-form");
var DataListComponent = /** @class */ (function () {
    function DataListComponent() {
        this.wrapItems = false;
        this.style = {};
        this.data = [];
        this.allowPaging = false;
        this.pageSize = 10;
        this.visible = true;
        this.emptyText = 'No records found.';
        this.defaultRowText = 'Template for index';
        this.loadData = new core_1.EventEmitter();
        this.first = 0;
    }
    DataListComponent.prototype.onPage = function (event) {
        this.first = event.first;
        this.rows = event.rows;
        this.callLoadData();
    };
    DataListComponent.prototype.load = function () {
        this.callLoadData();
    };
    DataListComponent.prototype.callLoadData = function () {
        this.loadData.next({
            skip: this.allowPaging ? this.first : null,
            top: this.allowPaging ? this.rows || this.pageSize : null
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "wrapItems", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], DataListComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "allowPaging", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "pageSize", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataListComponent.prototype, "count", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "emptyText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "defaultRowText", void 0);
    __decorate([
        core_1.ContentChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], DataListComponent.prototype, "template", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], DataListComponent.prototype, "loadData", void 0);
    DataListComponent = __decorate([
        core_1.Component({
            selector: 'rz-datalist',
            providers: [template_form_1.hideTemplateFromTemplateForm()],
            template: "\n    <p-dataList\n      [style]=\"style\"\n      *ngIf=\"visible && !wrapItems\"\n      [value]=\"data\"\n      [paginator]=\"allowPaging\"\n      [rows]=\"allowPaging ? pageSize : -1\"\n      [lazy]=\"loadData.observers.length > 0\"\n      (onPage)=\"onPage($event)\"\n      [totalRecords]=\"count\"\n      [emptyMessage]=\"emptyText\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-data>\n        <ng-template\n          [ngTemplateOutlet]=\"template\"\n          [ngTemplateOutletContext]=\"{$implicit: data}\"\n        ></ng-template>\n      </ng-template>\n      <ng-template *ngIf=\"!template\" pTemplate=\"item\" let-i=\"index\">\n        {{ defaultRowText }}: {{ i }}\n      </ng-template>\n    </p-dataList>\n    <p-dataGrid\n      [style]=\"style\"\n      *ngIf=\"visible && wrapItems\"\n      [value]=\"data\"\n      [paginator]=\"allowPaging\"\n      [rows]=\"allowPaging ? pageSize : -1\"\n      [lazy]=\"loadData.observers.length > 0\"\n      (onPage)=\"onPage($event)\"\n      [totalRecords]=\"count\"\n      [emptyMessage]=\"emptyText\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-data>\n        <ng-template\n          [ngTemplateOutlet]=\"template\"\n          [ngTemplateOutletContext]=\"{$implicit: data}\"\n        ></ng-template>\n      </ng-template>\n      <ng-template *ngIf=\"!template\" pTemplate=\"item\" let-i=\"index\">\n        {{ defaultRowText }}: {{ i }}\n      </ng-template>\n    </p-dataGrid>\n  "
        })
    ], DataListComponent);
    return DataListComponent;
}());
exports.DataListComponent = DataListComponent;
var DataListModule = /** @class */ (function () {
    function DataListModule() {
    }
    DataListModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, datagrid_1.DataGridModule, datalist_1.DataListModule],
            declarations: [DataListComponent],
            exports: [DataListComponent]
        })
    ], DataListModule);
    return DataListModule;
}());
exports.DataListModule = DataListModule;
