"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var calendar_1 = require("primeng/calendar");
var template_form_1 = require("./template-form");
var dates_1 = require("./dates");
var DatePickerComponent = /** @class */ (function (_super) {
    __extends(DatePickerComponent, _super);
    function DatePickerComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.style = {};
        _this.utc = true;
        _this.timeOnly = false;
        _this.inline = false;
        _this.dateFormat = 'mm/dd/yy';
        _this.hourFormat = '24';
        _this.showTime = false;
        _this.showSeconds = false;
        _this.selectionMode = 'single';
        _this.yearRange = '1950:2050';
        _this.placeholder = '';
        _this.localeSettings = dates_1.defaultLocaleSettings();
        return _this;
    }
    DatePickerComponent_1 = DatePickerComponent;
    Object.defineProperty(DatePickerComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            this.innerValue = value;
            if (this.utc) {
                if (Array.isArray(value)) {
                    value = value.map(dates_1.toUTC);
                }
                else {
                    value = dates_1.toUTC(value);
                }
            }
            this.onChange(value);
            this.change.next(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePickerComponent.prototype, "locale", {
        set: function (locale) {
            this.localeSettings = dates_1.toLocaleSettings(locale);
        },
        enumerable: true,
        configurable: true
    });
    DatePickerComponent.prototype.writeValue = function (value) {
        this.innerValue = typeof value == 'string' ? dates_1.parse(value, this.utc) : value;
    };
    DatePickerComponent.prototype.ngAfterContentInit = function () {
        if (this.calendar) {
            this.calendar.onUserInput = dates_1.onUserInput;
        }
    };
    var DatePickerComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "utc", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "timeOnly", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "inline", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "dateFormat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "hourFormat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "showTime", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "showSeconds", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "selectionMode", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "yearRange", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], DatePickerComponent.prototype, "value", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], DatePickerComponent.prototype, "locale", null);
    __decorate([
        core_1.ViewChild(calendar_1.Calendar),
        __metadata("design:type", Object)
    ], DatePickerComponent.prototype, "calendar", void 0);
    DatePickerComponent = DatePickerComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-datepicker',
            template: "\n    <p-calendar\n      appendTo=\"body\"\n      [style]=\"style\"\n      [styleClass]=\"disabled ? 'ui-state-disabled' : null\"\n      [showIcon]=\"true\"\n      [inputId]=\"name\"\n      [(ngModel)]=\"value\"\n      [locale]=\"localeSettings\"\n      [placeholder]=\"placeholder\"\n      [dateFormat]=\"dateFormat\"\n      [selectionMode]=\"selectionMode\"\n      [showTime]=\"showTime\"\n      [showSeconds]=\"showSeconds\"\n      [disabled]=\"disabled\"\n      [yearNavigator]=\"true\"\n      [yearRange]=\"yearRange\"\n      [monthNavigator]=\"true\"\n      [timeOnly]=\"timeOnly\"\n      [hourFormat]=\"hourFormat\"\n      [inline]=\"inline\"\n      (onBlur)=\"onTouched()\"\n    >\n    </p-calendar>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return DatePickerComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return DatePickerComponent_1; })
                }
            ]
        })
    ], DatePickerComponent);
    return DatePickerComponent;
}(template_form_1.InputComponent));
exports.DatePickerComponent = DatePickerComponent;
var DatePickerModule = /** @class */ (function () {
    function DatePickerModule() {
    }
    DatePickerModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, calendar_1.CalendarModule],
            declarations: [DatePickerComponent],
            exports: [DatePickerComponent]
        })
    ], DatePickerModule);
    return DatePickerModule;
}());
exports.DatePickerModule = DatePickerModule;
