"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var overlaypanel_1 = require("primeng/overlaypanel");
var datatable_1 = require("primeng/datatable");
var dropdown_1 = require("primeng/dropdown");
var get = require("lodash/get");
var button_1 = require("./button");
var template_form_1 = require("./template-form");
var grid_1 = require("./grid");
var DropDownDataGridColumnTemplate = /** @class */ (function () {
    function DropDownDataGridColumnTemplate(templateRef) {
        this.templateRef = templateRef;
    }
    DropDownDataGridColumnTemplate = __decorate([
        core_1.Directive({
            selector: '[dropdownDatagridColumnTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], DropDownDataGridColumnTemplate);
    return DropDownDataGridColumnTemplate;
}());
exports.DropDownDataGridColumnTemplate = DropDownDataGridColumnTemplate;
var DropDownDataGridColumn = /** @class */ (function () {
    function DropDownDataGridColumn(grid) {
        this.grid = grid;
        this.sortable = true;
    }
    Object.defineProperty(DropDownDataGridColumn.prototype, "style", {
        get: function () {
            var style = {};
            var width = this.width;
            if (width == null && this.grid && this.grid.columnWidth != 'auto') {
                width = this.grid.columnWidth;
            }
            if (width != null) {
                var value = width.toString();
                var unit = grid_1.getUnit(value);
                var numeric = grid_1.getNumeric(value);
                style.width = "" + numeric + unit;
            }
            return style;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridColumn.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridColumn.prototype, "property", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridColumn.prototype, "sortable", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridColumn.prototype, "width", void 0);
    __decorate([
        core_1.ContentChild(DropDownDataGridColumnTemplate),
        __metadata("design:type", core_1.TemplateRef)
    ], DropDownDataGridColumn.prototype, "template", void 0);
    DropDownDataGridColumn = __decorate([
        core_1.Component({
            selector: 'rz-dropdown-datagrid-column',
            template: ''
        }),
        __param(0, core_1.Host()),
        __param(0, core_1.Inject(core_1.forwardRef(function () { return DropDownDataGridComponent; }))),
        __metadata("design:paramtypes", [DropDownDataGridComponent])
    ], DropDownDataGridColumn);
    return DropDownDataGridColumn;
}());
exports.DropDownDataGridColumn = DropDownDataGridColumn;
var DropDownDataGridComponent = /** @class */ (function (_super) {
    __extends(DropDownDataGridComponent, _super);
    function DropDownDataGridComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.style = {};
        _this.emptyText = 'No records to display.';
        _this.allowFiltering = true;
        _this.allowSorting = true;
        _this.multiple = false;
        _this.columnWidth = 'auto';
        _this.loadData = new core_1.EventEmitter();
        _this.loading = false;
        _this.searchValue = '';
        _this.multiSortMeta = [];
        _this.skip = 0;
        _this.top = 10;
        _this.filter = '';
        _this.orderBy = '';
        return _this;
    }
    DropDownDataGridComponent_1 = DropDownDataGridComponent;
    Object.defineProperty(DropDownDataGridComponent.prototype, "pageSize", {
        get: function () {
            return this.top;
        },
        set: function (value) {
            this.top = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DropDownDataGridComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                if (this.valueProperty) {
                    this.change.next(this.selection);
                }
                else {
                    this.change.next(value);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DropDownDataGridComponent.prototype, "options", {
        get: function () {
            var _this = this;
            if (this.data) {
                var current_1 = this.value;
                if (!this.multiple) {
                    var item = this.valueProperty
                        ? this.data.find(function (i) { return i[_this.valueProperty] == current_1; })
                        : this.data.find(function (i) { return i == current_1; });
                    if (item) {
                        return [this.optionByItem(item)];
                    }
                    else if (this.selectedValue) {
                        return [this.optionByItem(this.selectedValue)];
                    }
                }
                else if (this.multiple) {
                    var items = this.selection || [];
                    var opts = items.map(function (item) { return _this.optionByItem(item); });
                    if (opts.length > 1) {
                        var labels = items.map(function (item) { return get(item, _this.textProperty); });
                        opts[0].label = [labels[0], labels[1]].join(', ') + ", ...";
                    }
                    return opts;
                }
            }
            return [];
        },
        enumerable: true,
        configurable: true
    });
    DropDownDataGridComponent.prototype.onToggle = function (op, event) {
        if (this.disabled != true) {
            op.toggle(event);
        }
    };
    DropDownDataGridComponent.prototype.optionByItem = function (item) {
        return {
            label: this.textProperty ? get(item, this.textProperty) : item,
            value: this.valueProperty ? get(item, this.valueProperty) : item
        };
    };
    DropDownDataGridComponent.prototype.updateValue = function () {
        var _this = this;
        if (this.selection) {
            if (this.valueProperty) {
                var newValue = this.multiple
                    ? this.selection.map(function (item) { return get(item, _this.valueProperty); })
                    : get(this.selection, this.valueProperty);
                this.value = newValue;
            }
            else {
                this.value = this.selection;
            }
        }
    };
    DropDownDataGridComponent.prototype.onSearch = function () {
        this.filter =
            this.searchValue && this.textProperty
                ? "contains(" + this.textProperty + ", '" + this.searchValue + "')"
                : '';
        this.skip = 0;
        this.callLoadData();
    };
    DropDownDataGridComponent.prototype.onSearchKeyPress = function (event) {
        if (event.keyCode === 13) {
            this.onSearch();
        }
    };
    DropDownDataGridComponent.prototype.onRowSelect = function (op, dropdown, event) {
        if (!this.multiple) {
            op.toggle(event, dropdown);
            this.updateValue();
        }
    };
    DropDownDataGridComponent.prototype.onClose = function (op, dropdown, event) {
        op.toggle(event, dropdown);
        this.updateValue();
    };
    DropDownDataGridComponent.prototype.onPage = function (event) {
        if (this.skip != event.first || this.top != event.rows) {
            this.skip = event.first;
            this.top = event.rows;
            this.callLoadData();
        }
    };
    DropDownDataGridComponent.prototype.onSort = function (event) {
        if (this.allowSorting && event.field) {
            var field = event.multisortmeta.find(function (i) { return i && i.field == event.field; });
            event.multisortmeta.splice(event.multisortmeta.indexOf(field), 1);
            event.multisortmeta.push({ field: event.field, order: event.order });
        }
        this.orderBy = this.allowSorting
            ? grid_1.orderByToString(event.multisortmeta)
            : '';
        this.skip = 0;
        this.callLoadData();
    };
    DropDownDataGridComponent.prototype.callLoadData = function () {
        this.loading = true;
        this.loadData.next({
            skip: this.skip,
            top: this.top,
            orderby: this.orderBy,
            filter: this.filter
        });
    };
    DropDownDataGridComponent.prototype.load = function () {
        this.callLoadData();
    };
    DropDownDataGridComponent.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('data')) {
            this.loading = false;
        }
        if (changes.hasOwnProperty('valueProperty') ||
            changes.hasOwnProperty('textProperty')) {
            this.internalColumns = this.textProperty
                ? [
                    {
                        property: this.textProperty,
                        title: this.textProperty,
                        sortable: true
                    }
                ]
                : [];
        }
    };
    var DropDownDataGridComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "emptyText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridComponent.prototype, "textProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridComponent.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], DropDownDataGridComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "selectedValue", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DropDownDataGridComponent.prototype, "count", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "allowFiltering", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "allowSorting", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownDataGridComponent.prototype, "columnWidth", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DropDownDataGridComponent.prototype, "isLoading", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], DropDownDataGridComponent.prototype, "loadData", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], DropDownDataGridComponent.prototype, "pageSize", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], DropDownDataGridComponent.prototype, "value", null);
    __decorate([
        core_1.ContentChildren(DropDownDataGridColumn),
        __metadata("design:type", core_1.QueryList)
    ], DropDownDataGridComponent.prototype, "columns", void 0);
    DropDownDataGridComponent = DropDownDataGridComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-dropdown-datagrid',
            template: "\n    <div\n      #dropdown\n      [ngStyle]=\"style\"\n      class=\"ui-lookup\"\n      (click)=\"onToggle(op, $event)\"\n    >\n      <p-dropdown\n        [disabled]=\"disabled\"\n        [options]=\"options\"\n        [(ngModel)]=\"value\"\n        [inputId]=\"name\"\n        [placeholder]=\"placeholder\"\n        readonly=\"true\"\n      >\n      </p-dropdown>\n    </div>\n    <p-overlayPanel appendTo=\"body\" #op>\n      <div class=\"ui-lookup-panel\">\n        <div class=\"ui-lookup-search\">\n          <input\n            #search\n            (keypress)=\"onSearchKeyPress($event)\"\n            *ngIf=\"allowFiltering\"\n            (input)=\"searchValue = $event.target.value\"\n            placeholder=\"Search...\"\n          />\n          <rz-button\n            *ngIf=\"allowFiltering\"\n            icon=\"search\"\n            (click)=\"onSearch()\"\n          ></rz-button>\n        </div>\n        <p-dataTable\n          [selectionMode]=\"multiple ? 'multiple' : 'single'\"\n          [(selection)]=\"selection\"\n          styleClass=\"ui-selectable\"\n          scrollable=\"true\"\n          scrollHeight=\"200px\"\n          scrollWidth=\"400px\"\n          responsive=\"true\"\n          alwaysShowPaginator=\"false\"\n          [lazy]=\"loadData.observers.length > 0\"\n          [loading]=\"isLoading || (loadData.observers.length > 0 && loading)\"\n          [value]=\"data\"\n          [totalRecords]=\"count\"\n          [emptyMessage]=\"emptyText\"\n          (onPage)=\"onPage($event)\"\n          (onSort)=\"onSort($event)\"\n          (onRowSelect)=\"onRowSelect(op, dropdown, $event)\"\n          [sortMode]=\"allowSorting ? 'single' : null\"\n          [rows]=\"pageSize\"\n          [multiSortMeta]=\"multiSortMeta\"\n          paginator=\"true\"\n          #dataTable\n        >\n          <p-column\n            *ngFor=\"\n              let column of columns.length ? columns : internalColumns;\n              let index = index\n            \"\n            [style]=\"column.style\"\n            [field]=\"column.property\"\n            [header]=\"column.title\"\n            [sortable]=\"\n              allowSorting && column.sortable\n                ? loadData.observers.length > 0\n                  ? 'custom'\n                  : true\n                : false\n            \"\n          >\n            <ng-template\n              *ngIf=\"column.template\"\n              pTemplate=\"body\"\n              let-data=\"rowData\"\n            >\n              <ng-template\n                [ngTemplateOutlet]=\"column.template.templateRef\"\n                [ngTemplateOutletContext]=\"{$implicit: data}\"\n              >\n              </ng-template>\n            </ng-template>\n          </p-column>\n        </p-dataTable>\n        <div *ngIf=\"multiple\" class=\"ui-lookup-select\">\n          <rz-button\n            text=\"Select\"\n            (click)=\"onClose(op, dropdown, $event)\"\n          ></rz-button>\n        </div>\n      </div>\n    </p-overlayPanel>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return DropDownDataGridComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return DropDownDataGridComponent_1; })
                }
            ]
        })
    ], DropDownDataGridComponent);
    return DropDownDataGridComponent;
}(template_form_1.InputComponent));
exports.DropDownDataGridComponent = DropDownDataGridComponent;
var DropDownDataGridModule = /** @class */ (function () {
    function DropDownDataGridModule() {
    }
    DropDownDataGridModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
                forms_1.FormsModule,
                button_1.ButtonModule,
                datatable_1.DataTableModule,
                overlaypanel_1.OverlayPanelModule,
                dropdown_1.DropdownModule
            ],
            declarations: [
                DropDownDataGridComponent,
                DropDownDataGridColumn,
                DropDownDataGridColumnTemplate
            ],
            exports: [
                DropDownDataGridComponent,
                DropDownDataGridColumn,
                DropDownDataGridColumnTemplate
            ]
        })
    ], DropDownDataGridModule);
    return DropDownDataGridModule;
}());
exports.DropDownDataGridModule = DropDownDataGridModule;
