"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var dropdown_1 = require("primeng/dropdown");
var multiselect_1 = require("primeng/multiselect");
var get = require("lodash/get");
var set = require("lodash/set");
var template_form_1 = require("./template-form");
var DropDownComponent = /** @class */ (function (_super) {
    __extends(DropDownComponent, _super);
    function DropDownComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.style = {};
        _this.allowFiltering = false;
        _this.multiple = false;
        _this.allowClear = false;
        return _this;
    }
    DropDownComponent_1 = DropDownComponent;
    Object.defineProperty(DropDownComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            var _this = this;
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                if (this.valueProperty) {
                    var data = this.data ? this.data : [];
                    var item = data.find(function (item) { return get(item, _this.valueProperty) == value; });
                    if (!item) {
                        item = {};
                        set(item, this.valueProperty, value);
                    }
                    this.change.next(item);
                }
                else {
                    this.change.next(value);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    DropDownComponent.prototype.text = function (item) {
        return this.textProperty ? get(item, this.textProperty) : item;
    };
    DropDownComponent.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('data') ||
            changes.hasOwnProperty('textProperty')) {
            this.setOptions();
        }
    };
    DropDownComponent.prototype.setOptions = function () {
        var _this = this;
        if (!this.data) {
            return;
        }
        this.options = this.data.map(function (item) {
            return {
                data: item,
                label: _this.textProperty ? get(item, _this.textProperty) : item,
                value: _this.valueProperty ? get(item, _this.valueProperty) : item
            };
        });
    };
    var DropDownComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], DropDownComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownComponent.prototype, "textProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownComponent.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DropDownComponent.prototype, "allowFiltering", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DropDownComponent.prototype, "filterPlaceholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DropDownComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DropDownComponent.prototype, "allowClear", void 0);
    __decorate([
        core_1.ContentChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], DropDownComponent.prototype, "template", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], DropDownComponent.prototype, "value", null);
    DropDownComponent = DropDownComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-dropdown',
            template: "\n    <p-dropdown\n      *ngIf=\"!multiple\"\n      appendTo=\"body\"\n      (blur)=\"onTouched()\"\n      [(ngModel)]=\"value\"\n      [style]=\"style\"\n      [options]=\"options\"\n      [inputId]=\"name\"\n      [filter]=\"allowFiltering\"\n      [showClear]=\"allowClear\"\n      [placeholder]=\"placeholder\"\n      [filterPlaceholder]=\"filterPlaceholder\"\n      [disabled]=\"disabled\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-data>\n        <ng-template\n          [ngTemplateOutlet]=\"template\"\n          [ngTemplateOutletContext]=\"{$implicit: data.data}\"\n        ></ng-template>\n      </ng-template>\n    </p-dropdown>\n    <p-multiSelect\n      *ngIf=\"multiple\"\n      appendTo=\"body\"\n      (blur)=\"onTouched()\"\n      [(ngModel)]=\"value\"\n      [style]=\"style\"\n      [options]=\"options\"\n      [inputId]=\"name\"\n      [filter]=\"allowFiltering\"\n      [defaultLabel]=\"placeholder\"\n      [filterPlaceHolder]=\"filterPlaceholder\"\n      [disabled]=\"disabled\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-data>\n        <ng-template\n          [ngTemplateOutlet]=\"template\"\n          [ngTemplateOutletContext]=\"{$implicit: data.data}\"\n        ></ng-template>\n      </ng-template>\n    </p-multiSelect>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return DropDownComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return DropDownComponent_1; })
                },
                template_form_1.hideTemplateFromTemplateForm()
            ]
        })
    ], DropDownComponent);
    return DropDownComponent;
}(template_form_1.InputComponent));
exports.DropDownComponent = DropDownComponent;
var DropDownModule = /** @class */ (function () {
    function DropDownModule() {
    }
    DropDownModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
                forms_1.FormsModule,
                dropdown_1.DropdownModule,
                multiselect_1.MultiSelectModule
            ],
            declarations: [DropDownComponent],
            exports: [DropDownComponent]
        })
    ], DropDownModule);
    return DropDownModule;
}());
exports.DropDownModule = DropDownModule;
