"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var platform_browser_1 = require("@angular/platform-browser");
var button_1 = require("primeng/button");
var template_form_1 = require("./template-form");
var FileInputComponent = /** @class */ (function (_super) {
    __extends(FileInputComponent, _super);
    function FileInputComponent(templateForm, sanitizer) {
        var _this = _super.call(this, templateForm) || this;
        _this.sanitizer = sanitizer;
        _this.select = new core_1.EventEmitter();
        _this.style = {};
        _this.accept = 'image/*';
        _this.chooseText = 'Choose';
        return _this;
    }
    FileInputComponent_1 = FileInputComponent;
    Object.defineProperty(FileInputComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
                if (value) {
                    this.dataURI = this.sanitizer.bypassSecurityTrustUrl(value);
                }
                this.isImage = /^data:image/.test(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    FileInputComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    FileInputComponent.prototype.onRemove = function () {
        this.value = null;
        this.onChange(null);
    };
    FileInputComponent.prototype.onFileSelect = function (event) {
        var _this = this;
        this.onTouched();
        var reader = new FileReader();
        var file = event.target.files[0];
        this.name = file.name;
        this.size = formatSize(file.size);
        this.select.next({
            file: file
        });
        reader.onload = function (event) {
            _this.value = event.target.result;
            _this.onChange(_this.value);
            _this.change.next(_this.value);
        };
        reader.readAsDataURL(file);
    };
    var FileInputComponent_1;
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FileInputComponent.prototype, "select", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FileInputComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FileInputComponent.prototype, "accept", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FileInputComponent.prototype, "chooseText", void 0);
    FileInputComponent = FileInputComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-file-input',
            styles: [
                "\n      img {\n        width: 100px;\n      }\n    "
            ],
            template: "\n    <div\n      class=\"ui-fileupload ui-widget\"\n      [ngClass]=\"{'ui-state-disabled': disabled}\"\n    >\n      <div class=\"ui-fileupload-buttonbar ui-widget-header ui-corner-top\">\n        <span\n          pButton\n          [label]=\"chooseText\"\n          [ngClass]=\"{'ui-state-disabled': disabled}\"\n          class=\"ui-fileupload-choose\"\n        >\n          <input\n            #input\n            [disabled]=\"disabled\"\n            type=\"file\"\n            (change)=\"onFileSelect($event)\"\n            [accept]=\"accept\"\n          />\n          <input type=\"hidden\" [(ngModel)]=\"value\" />\n        </span>\n      </div>\n      <div class=\"ui-fileupload-content ui-widget-content ui-corner-bottom\">\n        <div *ngIf=\"value\" class=\"ui-fileupload-files\">\n          <div class=\"ui-fileupload-row\">\n            <div><img *ngIf=\"isImage\" [src]=\"dataURI\" /></div>\n            <div>\n              <span *ngIf=\"name\">{{ name }}</span>\n            </div>\n            <div>\n              <span *ngIf=\"size\">{{ size }}</span>\n            </div>\n            <div>\n              <button\n                type=\"button\"\n                icon=\"fa fa-fw ui-icon-trash\"\n                pButton\n                (click)=\"onRemove()\"\n              ></button>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return FileInputComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return FileInputComponent_1; })
                }
            ]
        }),
        __param(0, core_1.Optional()), __param(0, core_1.Host()),
        __metadata("design:paramtypes", [template_form_1.TemplateFormComponent,
            platform_browser_1.DomSanitizer])
    ], FileInputComponent);
    return FileInputComponent;
}(template_form_1.InputComponent));
exports.FileInputComponent = FileInputComponent;
function formatSize(bytes) {
    var decimals = 2;
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
    var index = Math.floor(Math.log(bytes) / Math.log(1024));
    var numeric = bytes / Math.pow(1024, index);
    return numeric.toFixed(decimals) + " " + sizes[index];
}
var FileInputModule = /** @class */ (function () {
    function FileInputModule() {
    }
    FileInputModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, button_1.ButtonModule],
            declarations: [FileInputComponent],
            exports: [FileInputComponent]
        })
    ], FileInputModule);
    return FileInputModule;
}());
exports.FileInputModule = FileInputModule;
