import { NgZone, QueryList, SimpleChanges, ElementRef, EventEmitter, Injector, KeyValueDiffers } from '@angular/core';
export interface GoogleMapPosition {
    lat: number;
    lng: number;
}
export declare class GoogleMapMarker {
    private zone;
    private differs;
    position: GoogleMapPosition;
    title: string;
    label: string;
    map: any;
    google: any;
    private marker;
    private differ;
    private _map;
    private _google;
    click: EventEmitter<any>;
    constructor(zone: NgZone, differs: KeyValueDiffers);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    ngDoCheck(): void;
    private createMarker;
}
export declare class GoogleMapComponent {
    private injector;
    private zone;
    private differs;
    style: any;
    apiKey: string;
    markers: any[];
    center: GoogleMapPosition;
    zoom: number;
    mapInit: EventEmitter<any>;
    mapClick: EventEmitter<any>;
    markerClick: EventEmitter<any>;
    markerChildren: QueryList<GoogleMapMarker>;
    instance: any;
    google: any;
    private differ;
    private _zoom;
    wrapper: ElementRef;
    constructor(injector: Injector, zone: NgZone, differs: KeyValueDiffers);
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    onMarkerClick(marker: any): void;
    private api;
}
export declare class GoogleMapModule {
}
