"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var document_token_1 = require("./document.token");
var GoogleMapMarker = /** @class */ (function () {
    function GoogleMapMarker(zone, differs) {
        this.zone = zone;
        this.differs = differs;
        this.position = { lat: 0, lng: 0 };
        this.click = new core_1.EventEmitter();
    }
    Object.defineProperty(GoogleMapMarker.prototype, "map", {
        get: function () {
            return this._map;
        },
        set: function (value) {
            this._map = value;
            this.createMarker();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GoogleMapMarker.prototype, "google", {
        get: function () {
            return this._google;
        },
        set: function (value) {
            this._google = value;
            this.createMarker();
        },
        enumerable: true,
        configurable: true
    });
    GoogleMapMarker.prototype.ngOnChanges = function (changes) {
        if (this.marker) {
            if (changes.hasOwnProperty('position')) {
                this.marker.setPosition(this.position);
            }
            if (changes.hasOwnProperty('title')) {
                this.marker.setTitle(this.title);
            }
            if (changes.hasOwnProperty('label')) {
                this.marker.setLabel(this.label);
            }
        }
    };
    GoogleMapMarker.prototype.ngOnDestroy = function () {
        if (this.marker) {
            this.google.maps.event.clearInstanceListeners(this.marker);
            this.marker.setMap(null);
        }
    };
    GoogleMapMarker.prototype.ngDoCheck = function () {
        if (this.position && !this.differ) {
            this.differ = this.differs.find(this.position).create();
        }
        if (this.differ) {
            var changes = this.differ.diff(this.position);
            if (changes && this.marker) {
                this.marker.setPosition(this.position);
            }
        }
    };
    GoogleMapMarker.prototype.createMarker = function () {
        var _this = this;
        if (!this.marker && this.map && this.google) {
            this.marker = new this.google.maps.Marker({
                position: this.position,
                title: this.title,
                label: this.label
            });
            this.marker.addListener('click', function (event) {
                _this.zone.run(function () { return _this.click.next(); });
            });
            this.marker.setMap(this.map);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GoogleMapMarker.prototype, "position", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GoogleMapMarker.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GoogleMapMarker.prototype, "label", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], GoogleMapMarker.prototype, "map", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], GoogleMapMarker.prototype, "google", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GoogleMapMarker.prototype, "click", void 0);
    GoogleMapMarker = __decorate([
        core_1.Component({
            selector: 'rz-googlemap-marker',
            template: ""
        }),
        __metadata("design:paramtypes", [core_1.NgZone, core_1.KeyValueDiffers])
    ], GoogleMapMarker);
    return GoogleMapMarker;
}());
exports.GoogleMapMarker = GoogleMapMarker;
var GoogleMapComponent = /** @class */ (function () {
    function GoogleMapComponent(injector, zone, differs) {
        this.injector = injector;
        this.zone = zone;
        this.differs = differs;
        this.style = {};
        this.center = { lat: 0, lng: 0 };
        this.mapInit = new core_1.EventEmitter();
        this.mapClick = new core_1.EventEmitter();
        this.markerClick = new core_1.EventEmitter();
        this._zoom = 8;
    }
    Object.defineProperty(GoogleMapComponent.prototype, "zoom", {
        get: function () {
            return this._zoom;
        },
        set: function (value) {
            this._zoom = value;
            if (this.instance) {
                this.instance.setZoom(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    GoogleMapComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.api().then(function (google) {
            _this.google = google;
            _this.instance = new google.maps.Map(_this.wrapper.nativeElement, {
                center: _this.center,
                zoom: _this.zoom
            });
            _this.instance.addListener('click', function (event) { });
            _this.instance.addListener('click', function (event) {
                _this.zone.run(function () {
                    _this.mapClick.next({
                        position: {
                            lat: event.latLng.lat(),
                            lng: event.latLng.lng()
                        }
                    });
                });
            });
            _this.markerChildren.forEach(function (marker) {
                marker.google = google;
                marker.map = _this.instance;
                marker.click.subscribe(function () { return _this.onMarkerClick(marker); });
            });
            _this.mapInit.emit({
                instance: _this.instance,
                google: _this.google
            });
        });
    };
    GoogleMapComponent.prototype.ngDoCheck = function () {
        if (this.center && !this.differ) {
            this.differ = this.differs.find(this.center).create();
        }
        if (this.differ) {
            var changes = this.differ.diff(this.center);
            if (changes && this.instance) {
                this.instance.setCenter(this.center);
            }
        }
    };
    GoogleMapComponent.prototype.onMarkerClick = function (marker) {
        this.markerClick.next({ marker: marker });
    };
    GoogleMapComponent.prototype.api = function () {
        var _this = this;
        var defaultView = this.injector.get(document_token_1.DOCUMENT_TOKEN, document).defaultView;
        return new Promise(function (resolve, reject) {
            if (defaultView.google && defaultView.google.maps) {
                return resolve(defaultView.google);
            }
            loadGoogleMaps(defaultView, _this.apiKey, resolve, reject);
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GoogleMapComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GoogleMapComponent.prototype, "apiKey", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], GoogleMapComponent.prototype, "markers", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GoogleMapComponent.prototype, "center", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], GoogleMapComponent.prototype, "zoom", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GoogleMapComponent.prototype, "mapInit", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GoogleMapComponent.prototype, "mapClick", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GoogleMapComponent.prototype, "markerClick", void 0);
    __decorate([
        core_1.ContentChildren(GoogleMapMarker),
        __metadata("design:type", core_1.QueryList)
    ], GoogleMapComponent.prototype, "markerChildren", void 0);
    __decorate([
        core_1.ViewChild('wrapper'),
        __metadata("design:type", core_1.ElementRef)
    ], GoogleMapComponent.prototype, "wrapper", void 0);
    GoogleMapComponent = __decorate([
        core_1.Component({
            selector: 'rz-googlemap',
            template: "\n    <div [ngStyle]=\"style\" class=\"ui-map\">\n      <div class=\"ui-map-container\" #wrapper></div>\n      <rz-googlemap-marker\n        *ngFor=\"let marker of markers\"\n        [google]=\"google\"\n        (click)=\"onMarkerClick(marker)\"\n        [map]=\"instance\"\n        [position]=\"marker.position\"\n        [title]=\"marker.title\"\n        [label]=\"marker.label\"\n      >\n      </rz-googlemap-marker>\n      <ng-content> </ng-content>\n    </div>\n  "
        }),
        __metadata("design:paramtypes", [core_1.Injector,
            core_1.NgZone,
            core_1.KeyValueDiffers])
    ], GoogleMapComponent);
    return GoogleMapComponent;
}());
exports.GoogleMapComponent = GoogleMapComponent;
var resolveCallbacks = [];
var rejectCallbacks = [];
function loadGoogleMaps(defaultView, apiKey, resolve, reject) {
    resolveCallbacks.push(resolve);
    rejectCallbacks.push(reject);
    if (defaultView['rz_map_init']) {
        return;
    }
    defaultView['rz_map_init'] = function () {
        resolveCallbacks.forEach(function (resolve) { return resolve(defaultView.google); });
    };
    var document = defaultView.document;
    var script = document.createElement('script');
    script.src = "https://maps.googleapis.com/maps/api/js?" + (apiKey ? "key=" + apiKey + "&" : '') + "callback=rz_map_init";
    script.async = true;
    script.defer = true;
    script.onerror = function (err) {
        rejectCallbacks.forEach(function (reject) { return reject(err); });
    };
    document.body.appendChild(script);
}
var GoogleMapModule = /** @class */ (function () {
    function GoogleMapModule() {
    }
    GoogleMapModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [GoogleMapComponent, GoogleMapMarker],
            exports: [GoogleMapComponent, GoogleMapMarker]
        })
    ], GoogleMapModule);
    return GoogleMapModule;
}());
exports.GoogleMapModule = GoogleMapModule;
