"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var router_1 = require("@angular/router");
var LinkComponent = /** @class */ (function () {
    function LinkComponent(differs) {
        this.differs = differs;
        this.style = {};
        this.classList = {};
    }
    Object.defineProperty(LinkComponent.prototype, "path", {
        set: function (value) {
            this.route = null;
            this.href = null;
            if (value) {
                if (value.startsWith('/') || value.includes('://')) {
                    this.href = value;
                }
                else {
                    this.route = "/" + value;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    LinkComponent.prototype.ngDoCheck = function () {
        if (!this.differ && this.parameters) {
            this.differ = this.differs.find(this.parameters).create();
        }
        if (this.differ) {
            var changes = this.differ.diff(this.parameters);
            if (changes && this.route) {
                var _a = this.route.split('/'), _ = _a[0], path = _a[1];
                var segments = this.parameters.map(function (parameter) { return parameter.value; });
                this.route = "/" + [path].concat(segments).join('/');
            }
        }
    };
    LinkComponent.prototype.onClick = function (event) {
        event.stopPropagation();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LinkComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LinkComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LinkComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], LinkComponent.prototype, "parameters", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LinkComponent.prototype, "classList", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LinkComponent.prototype, "target", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], LinkComponent.prototype, "path", null);
    LinkComponent = __decorate([
        core_1.Component({
            selector: 'rz-link',
            template: "\n    <a\n      *ngIf=\"route\"\n      [routerLink]=\"route\"\n      [target]=\"target\"\n      class=\"link\"\n      [ngClass]=\"classList\"\n      (click)=\"onClick($event)\"\n      [ngStyle]=\"style\"\n    >\n      <i class=\"material-icons link-icon\" *ngIf=\"icon\">{{ icon }}</i\n      ><span class=\"link-text\">{{ text }}</span>\n    </a>\n    <a\n      *ngIf=\"!route\"\n      [attr.href]=\"href\"\n      [attr.target]=\"target\"\n      class=\"link\"\n      [ngClass]=\"classList\"\n      [ngStyle]=\"style\"\n      (click)=\"onClick($event)\"\n    >\n      <i class=\"material-icons link-icon\" *ngIf=\"icon\">{{ icon }}</i\n      ><span class=\"link-text\">{{ text }}</span>\n    </a>\n  "
        }),
        __metadata("design:paramtypes", [core_1.IterableDiffers])
    ], LinkComponent);
    return LinkComponent;
}());
exports.LinkComponent = LinkComponent;
var LinkModule = /** @class */ (function () {
    function LinkModule() {
    }
    LinkModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, router_1.RouterModule],
            declarations: [LinkComponent],
            exports: [LinkComponent]
        })
    ], LinkModule);
    return LinkModule;
}());
exports.LinkModule = LinkModule;
