"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var button_1 = require("./button");
var LoginComponent = /** @class */ (function () {
    function LoginComponent(formBuilder) {
        this.formBuilder = formBuilder;
        this.style = {};
        this.login = new core_1.EventEmitter();
        this.register = new core_1.EventEmitter();
        this.resetPassword = new core_1.EventEmitter();
        this.allowRegister = true;
        this.allowResetPassword = true;
        this.loginText = 'Login';
        this.registerText = 'Sign up';
        this.registerMessageText = "Don't have an account yet?";
        this.resetPasswordText = 'Forgot password';
        this.userText = 'Username';
        this.userRequired = 'Username is required';
        this.passwordText = 'Password';
        this.passwordRequired = 'Password is required';
    }
    LoginComponent.prototype.ngOnInit = function () {
        this.form = this.formBuilder.group({
            username: ['', forms_1.Validators.required],
            password: ['', forms_1.Validators.required]
        });
    };
    LoginComponent.prototype.onSubmit = function (event) {
        event.stopPropagation();
        event.preventDefault();
        this.submitted = true;
        if (this.form.valid) {
            this.login.next(this.form.value);
        }
    };
    LoginComponent.prototype.onRegister = function () {
        this.register.next();
    };
    LoginComponent.prototype.onResetPassword = function (event) {
        event.preventDefault();
        if (this.form.value.username) {
            this.resetPassword.next(this.form.value);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "login", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "register", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "resetPassword", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "allowRegister", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "allowResetPassword", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "loginText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "registerText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "registerMessageText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "resetPasswordText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "userText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "userRequired", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "passwordText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LoginComponent.prototype, "passwordRequired", void 0);
    LoginComponent = __decorate([
        core_1.Component({
            selector: 'rz-login',
            template: "\n    <div class=\"login\" [ngStyle]=\"style\">\n      <form [formGroup]=\"form\" class=\"ui-form\" (submit)=\"onSubmit($event)\">\n        <div class=\"row form-group\">\n          <label class=\"col-sm-3 col-form-label\" for=\"username\">{{ userText }}</label>\n          <div class=\"col\">\n            <input class=\"textbox\" formControlName=\"username\" id=\"username\">\n            <div class=\"md-inputfield\" *ngIf=\"(form.controls.username.touched || submitted) && form.controls.username.errors?.required\">\n              <div class=\"ui-message ui-messages-error ui-corner-all\">\n                {{ userRequired }}\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"row form-group\">\n          <label class=\"col-sm-3 col-form-label\" for=\"password\">{{ passwordText }}</label>\n          <div class=\"col\">\n            <input class=\"textbox\" type=\"password\" formControlName=\"password\" id=\"password\">\n            <div class=\"md-inputfield\" *ngIf=\"(form.controls.password.touched || submitted) && form.controls.password.errors?.required\">\n              <div class=\"ui-message ui-messages-error ui-corner-all\">\n                {{ passwordRequired }}\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"row form-group\">\n          <div class=\"offset-sm-3 col login-buttons\">\n            <rz-button buttonType=\"submit\" buttonStyle=\"primary\" [text]=\"loginText\"></rz-button>\n            <a *ngIf=\"allowResetPassword\" (click)=\"onResetPassword($event)\">{{ resetPasswordText }}</a>\n          </div>\n        </div>\n      </form>\n      <div class=\"register\" *ngIf=\"allowRegister\">\n        {{ registerMessageText }} <rz-button (click)=\"onRegister()\" buttonStyle=\"secondary\" [text]=\"registerText\"></rz-button>\n      </div>\n    </div>\n  "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], LoginComponent);
    return LoginComponent;
}());
exports.LoginComponent = LoginComponent;
var LoginModule = /** @class */ (function () {
    function LoginModule() {
    }
    LoginModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.ReactiveFormsModule, button_1.ButtonModule],
            declarations: [LoginComponent],
            exports: [LoginComponent]
        })
    ], LoginModule);
    return LoginModule;
}());
exports.LoginModule = LoginModule;
