"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var navigation_1 = require("./navigation");
var MenuItemComponent = /** @class */ (function (_super) {
    __extends(MenuItemComponent, _super);
    function MenuItemComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MenuItemComponent_1 = MenuItemComponent;
    var MenuItemComponent_1;
    __decorate([
        core_1.ContentChildren(MenuItemComponent_1),
        __metadata("design:type", core_1.QueryList)
    ], MenuItemComponent.prototype, "items", void 0);
    MenuItemComponent = MenuItemComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-menu-item',
            template: ""
        })
    ], MenuItemComponent);
    return MenuItemComponent;
}(navigation_1.NavigationItemComponent));
exports.MenuItemComponent = MenuItemComponent;
var MenuComponent = /** @class */ (function () {
    function MenuComponent(elementRef) {
        var _this = this;
        this.elementRef = elementRef;
        this.style = {};
        this.className = '';
        this.click = new core_1.EventEmitter();
        this.ngUnsubscribe = new rxjs_1.Subject();
        this.childrenToItems = function () {
            _this.items = navigation_1.childrenToItems(_this.children.toArray());
        };
    }
    MenuComponent.prototype.ngAfterContentInit = function () {
        if (this.children) {
            this.childrenToItems();
            this.children.changes.subscribe(this.childrenToItems);
        }
    };
    MenuComponent.prototype.ngOnDestroy = function () {
        this.ngUnsubscribe.next();
        this.ngUnsubscribe.complete();
    };
    MenuComponent.prototype.onClick = function (event) {
        if (!this.elementRef.nativeElement.contains(event.target)) {
            this.menu.close();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], MenuComponent.prototype, "items", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], MenuComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input('class'),
        __metadata("design:type", String)
    ], MenuComponent.prototype, "className", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], MenuComponent.prototype, "click", void 0);
    __decorate([
        core_1.ContentChildren(MenuItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], MenuComponent.prototype, "children", void 0);
    __decorate([
        core_1.ViewChild(navigation_1.SubMenuComponent),
        __metadata("design:type", navigation_1.SubMenuComponent)
    ], MenuComponent.prototype, "menu", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], MenuComponent.prototype, "onClick", null);
    MenuComponent = __decorate([
        core_1.Component({
            selector: 'rz-menu',
            template: "\n    <ul [ngStyle]=\"style\" class=\"menu\" [ngClass]=\"[className]\" rz-submenu\n        (click)=\"click.next($event)\" [horizontal]=\"true\" [items]=\"items\">\n    </ul>\n  "
        }),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], MenuComponent);
    return MenuComponent;
}());
exports.MenuComponent = MenuComponent;
var MenuModule = /** @class */ (function () {
    function MenuModule() {
    }
    MenuModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, navigation_1.NavigationModule],
            declarations: [MenuComponent, MenuItemComponent],
            exports: [MenuComponent, MenuItemComponent]
        })
    ], MenuModule);
    return MenuModule;
}());
exports.MenuModule = MenuModule;
