import { TemplateRef, EventEmitter } from '@angular/core';
import { Router, RouterLinkActive } from '@angular/router';
export interface NavigationItem {
    text: string;
    icon: string;
    image: string;
    path: string;
    href: string;
    route: string;
    selected: boolean;
    items: NavigationItem[];
    siblings: NavigationItem[];
    template: TemplateRef<any>;
}
export declare abstract class NavigationItemComponent {
    text: string;
    image: string;
    icon: string;
    selected: boolean;
    template: TemplateRef<any>;
    path: string;
    href: string;
    route: string;
}
export declare function childrenToItems(children: any[]): NavigationItem[] | null;
export declare function syncWithRouter(items: NavigationItem[], router: Router, path?: NavigationItem[]): void;
export declare class SubMenuComponent {
    horizontal: boolean;
    selectedIndex: number | null;
    closeOnClick: boolean;
    navigate: EventEmitter<any>;
    click: EventEmitter<any>;
    children: NavigationItem[];
    items: NavigationItem[];
    routerLink: RouterLinkActive;
    private active;
    onMouseEnter(index: number): void;
    onClick(event: any, item: NavigationItem, index: number): void;
    close(): void;
}
export declare class NavigationModule {
}
