"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var router_1 = require("@angular/router");
var animations_1 = require("@angular/animations");
var transition_1 = require("./transition");
var NavigationItemComponent = /** @class */ (function () {
    function NavigationItemComponent() {
    }
    Object.defineProperty(NavigationItemComponent.prototype, "path", {
        get: function () {
            return this.href || this.route;
        },
        set: function (value) {
            this.route = null;
            this.href = null;
            if (value) {
                if (value.startsWith('/') || value.includes('://')) {
                    this.href = value;
                }
                else {
                    this.route = value;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NavigationItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NavigationItemComponent.prototype, "image", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NavigationItemComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], NavigationItemComponent.prototype, "selected", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_1.TemplateRef)
    ], NavigationItemComponent.prototype, "template", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], NavigationItemComponent.prototype, "path", null);
    return NavigationItemComponent;
}());
exports.NavigationItemComponent = NavigationItemComponent;
function childrenToItems(children) {
    if (children.length > 0) {
        var siblings_1 = children.map(function (item) {
            return __assign({}, item, { path: item.path, 
                // https://github.com/angular/angular/issues/10098
                items: childrenToItems(item.items.filter(function (child) { return child != item; })) });
        });
        siblings_1.forEach(function (item) {
            item.siblings = siblings_1;
        });
        return siblings_1;
    }
    else {
        return null;
    }
}
exports.childrenToItems = childrenToItems;
function syncWithRouter(items, router, path) {
    if (path === void 0) { path = []; }
    items.forEach(function (item) {
        if (item.route && router.isActive(item.route, /*exact*/ true)) {
            path.forEach(function (parent) {
                parent.siblings.forEach(function (item) {
                    item.selected = false;
                });
                parent.selected = true;
                parent.items = parent.items.slice();
            });
        }
        else if (Array.isArray(item.items)) {
            path.push(item);
            syncWithRouter(item.items, router, path);
            path.pop();
        }
    });
}
exports.syncWithRouter = syncWithRouter;
var SubMenuComponent = /** @class */ (function () {
    function SubMenuComponent() {
        this.horizontal = false;
        this.selectedIndex = null;
        this.closeOnClick = true;
        this.navigate = new core_1.EventEmitter();
        this.click = new core_1.EventEmitter();
        this.items = [];
        this.active = false;
    }
    Object.defineProperty(SubMenuComponent.prototype, "children", {
        set: function (value) {
            this.items = value;
            if (value) {
                this.selectedIndex = value.findIndex(function (item) { return item.selected; });
            }
        },
        enumerable: true,
        configurable: true
    });
    SubMenuComponent.prototype.onMouseEnter = function (index) {
        if (this.horizontal && this.active) {
            this.selectedIndex = index;
        }
    };
    SubMenuComponent.prototype.onClick = function (event, item, index) {
        event.stopPropagation();
        if (this.horizontal) {
            this.active = !this.active;
        }
        this.selectedIndex = this.selectedIndex == index ? null : index;
        if (!item.items) {
            this.navigate.next();
        }
        if (!item.route && !item.href) {
            this.click.next(__assign({}, item, { index: index }));
        }
    };
    SubMenuComponent.prototype.close = function () {
        if (this.closeOnClick) {
            this.selectedIndex = null;
            this.active = false;
            this.navigate.next();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], SubMenuComponent.prototype, "horizontal", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], SubMenuComponent.prototype, "selectedIndex", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], SubMenuComponent.prototype, "closeOnClick", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], SubMenuComponent.prototype, "navigate", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], SubMenuComponent.prototype, "click", void 0);
    __decorate([
        core_1.Input('items'),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], SubMenuComponent.prototype, "children", null);
    __decorate([
        core_1.ViewChild(router_1.RouterLinkActive),
        __metadata("design:type", router_1.RouterLinkActive)
    ], SubMenuComponent.prototype, "routerLink", void 0);
    SubMenuComponent = __decorate([
        core_1.Component({
            selector: '[rz-submenu]',
            template: "\n    <li\n      *ngFor=\"let item of items; index as index\"\n      class=\"navigation-item\"\n      [ngClass]=\"{'navigation-item-active': selectedIndex == index}\"\n    >\n      <div\n        class=\"navigation-item-wrapper\"\n        [routerLinkActiveOptions]=\"{exact: true}\"\n        [routerLinkActive]=\"item.route ? 'navigation-item-wrapper-active' : ''\"\n      >\n        <a\n          *ngIf=\"item.route\"\n          (click)=\"onClick($event, item, index)\"\n          (mouseenter)=\"onMouseEnter(index)\"\n          [style.paddingLeft.rem]=\"level\"\n          [routerLinkActiveOptions]=\"{exact: true}\"\n          [routerLinkActive]=\"item.route ? 'navigation-item-link-active' : ''\"\n          [routerLink]=\"['/' + item.route]\"\n          class=\"navigation-item-link\"\n        >\n          <i class=\"material-icons navigation-item-icon\" *ngIf=\"item.icon\">{{\n            item.icon\n          }}</i>\n          <img\n            class=\"navigation-item-icon\"\n            [src]=\"item.image\"\n            *ngIf=\"item.image\"\n          />\n          <span class=\"navigation-item-text\">{{ item.text }}</span>\n          <i\n            [@rotate]=\"selectedIndex == index ? 'active' : 'inactive'\"\n            class=\"material-icons navigation-item-icon-children\"\n            *ngIf=\"item.items\"\n            >keyboard_arrow_down</i\n          >\n        </a>\n        <a\n          *ngIf=\"item.href\"\n          (click)=\"onClick($event, item, index)\"\n          (mouseenter)=\"onMouseEnter(index)\"\n          [style.paddingLeft.rem]=\"level\"\n          class=\"navigation-item-link\"\n          [attr.href]=\"item.href\"\n        >\n          <i class=\"material-icons navigation-item-icon\" *ngIf=\"item.icon\">{{\n            item.icon\n          }}</i>\n          <img\n            class=\"navigation-item-icon\"\n            [src]=\"item.image\"\n            *ngIf=\"item.image\"\n          />\n          <span class=\"navigation-item-text\">{{ item.text }}</span>\n          <i\n            [@rotate]=\"selectedIndex == index ? 'active' : 'inactive'\"\n            class=\"material-icons navigation-item-icon-children\"\n            *ngIf=\"item.items\"\n            >keyboard_arrow_down</i\n          >\n        </a>\n        <div\n          *ngIf=\"!item.href && !item.route\"\n          (click)=\"onClick($event, item, index)\"\n          (mouseenter)=\"onMouseEnter(index)\"\n          [style.paddingLeft.rem]=\"level\"\n          class=\"navigation-item-link\"\n        >\n          <i class=\"material-icons navigation-item-icon\" *ngIf=\"item.icon\">{{\n            item.icon\n          }}</i>\n          <img\n            class=\"navigation-item-icon\"\n            [src]=\"item.image\"\n            *ngIf=\"item.image\"\n          />\n          <span *ngIf=\"!item.template\" class=\"navigation-item-text\">{{\n            item.text\n          }}</span>\n          <div class=\"item-text\" *ngIf=\"item.template\">\n            <ng-template [ngTemplateOutlet]=\"item.template\"></ng-template>\n          </div>\n          <i\n            [@rotate]=\"selectedIndex == index ? 'active' : 'inactive'\"\n            class=\"material-icons navigation-item-icon-children\"\n            *ngIf=\"item.items\"\n            >keyboard_arrow_down</i\n          >\n        </div>\n      </div>\n      <ul\n        rz-submenu\n        *ngIf=\"item.items\"\n        class=\"navigation-menu\"\n        [items]=\"item.items\"\n        [closeOnClick]=\"closeOnClick\"\n        (navigate)=\"close()\"\n        (click)=\"click.next($event)\"\n        [@open]=\"selectedIndex == index ? 'visible' : 'hidden'\"\n      ></ul>\n    </li>\n  ",
            animations: [
                animations_1.trigger('rotate', [
                    animations_1.state('active', animations_1.style({
                        transform: 'rotate(-180deg)'
                    })),
                    animations_1.state('inactive', animations_1.style({
                        transform: 'rotate(0deg)'
                    })),
                    animations_1.transition('active <=> inactive', animations_1.animate(transition_1.EASING))
                ]),
                animations_1.trigger('open', [
                    animations_1.state('visible', animations_1.style({
                        height: '*'
                    })),
                    animations_1.state('hidden', animations_1.style({
                        height: '0px'
                    })),
                    animations_1.transition('visible <=> hidden', animations_1.animate(transition_1.EASING))
                ])
            ]
        })
    ], SubMenuComponent);
    return SubMenuComponent;
}());
exports.SubMenuComponent = SubMenuComponent;
var NavigationModule = /** @class */ (function () {
    function NavigationModule() {
    }
    NavigationModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, router_1.RouterModule],
            declarations: [SubMenuComponent],
            exports: [SubMenuComponent]
        })
    ], NavigationModule);
    return NavigationModule;
}());
exports.NavigationModule = NavigationModule;
