"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var template_form_1 = require("./template-form");
var shared_1 = require("./shared");
var NumericComponent = /** @class */ (function (_super) {
    __extends(NumericComponent, _super);
    function NumericComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.step = 1;
        _this.decimalSeparator = '.';
        _this.thousandSeparator = ',';
        _this.autofocus = false;
        _this.selectOnFocus = false;
        _this.autoComplete = true;
        _this.style = {};
        _this.readOnly = false;
        _this.placeholder = '';
        return _this;
    }
    NumericComponent_1 = NumericComponent;
    NumericComponent.prototype.onFocus = function (event) {
        if (this.selectOnFocus) {
            setTimeout(function () {
                event.target.select();
            }, 50);
        }
    };
    NumericComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    NumericComponent.prototype.onSpinUp = function (input, event) {
        this.spin(input, event, 1);
    };
    NumericComponent.prototype.onPaste = function (event) {
        var _a = event.clipboardData, clipboardData = _a === void 0 ? window.clipboardData : _a;
        if (clipboardData) {
            var value = clipboardData.getData('text');
            if (value && /^-?\d*\.?\d*$/.test(value)) {
                return;
            }
            event.preventDefault();
        }
    };
    NumericComponent.prototype.onSpinDown = function (input, event) {
        this.spin(input, event, -1);
    };
    NumericComponent.prototype.onKeyPress = function (event) {
        var metaKey = event.metaKey, ctrlKey = event.ctrlKey, charCode = event.charCode, keyCode = event.keyCode;
        if (metaKey || ctrlKey || keyCode == 9 || keyCode == 8 || keyCode == 13) {
            return;
        }
        var ch = String.fromCharCode(charCode);
        if (/^[-\d,.]$/.test(ch)) {
            return;
        }
        event.preventDefault();
    };
    NumericComponent.prototype.spin = function (input, event, direction) {
        event.preventDefault();
        if (this.readOnly || this.disabled) {
            return;
        }
        var numericValue = parseFloat(input.value);
        var min = typeof this.min == 'string' ? parseFloat(this.min) : this.min;
        var max = typeof this.max == 'string' ? parseFloat(this.max) : this.max;
        var inputValue = isNaN(numericValue) ? min || 0 : numericValue;
        var step = isNaN(numericValue) ? 0 : this.step * direction;
        var _a = this.step.toString().split(/[,.]/), whole = _a[0], _b = _a[1], fraction = _b === void 0 ? '' : _b;
        var precision = fraction.length;
        var value = inputValue + step;
        if (precision > 0) {
            value = parseFloat(value.toFixed(precision));
        }
        if (!isNaN(min)) {
            value = Math.max(min, value);
        }
        if (!isNaN(max)) {
            value = Math.min(max, value);
        }
        this.value = value;
    };
    var NumericComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "step", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], NumericComponent.prototype, "min", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], NumericComponent.prototype, "max", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "decimalSeparator", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "thousandSeparator", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "autofocus", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "selectOnFocus", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "autoComplete", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "readOnly", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.ViewChild('input'),
        __metadata("design:type", core_1.ElementRef)
    ], NumericComponent.prototype, "input", void 0);
    NumericComponent = NumericComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-numeric',
            template: "\n    <span\n      class=\"ui-spinner ui-widget ui-corner-all\"\n      [ngStyle]=\"style\"\n      [ngClass]=\"{'ui-state-disabled': disabled}\"\n    >\n      <input\n        #input\n        type=\"number\"\n        class=\"ui-spinner-input ui-inputtext ui-widget ui-state-default ui-corner-all\"\n        [readonly]=\"readOnly\"\n        [disabled]=\"disabled\"\n        [id]=\"name\"\n        [attr.min]=\"min\"\n        [attr.max]=\"max\"\n        [attr.step]=\"step\"\n        [rz-autofocus]=\"autofocus\"\n        [placeholder]=\"placeholder\"\n        [autocomplete]=\"autoComplete ? 'on' : 'off'\"\n        [(ngModel)]=\"value\"\n        (focus)=\"onFocus($event)\"\n        (blur)=\"onTouched()\"\n        (paste)=\"onPaste($event)\"\n        (keypress)=\"onKeyPress($event)\"\n        (change)=\"$event.stopPropagation()\"\n      />\n      <button\n        (mousedown)=\"onSpinUp(input, $event)\"\n        (click)=\"$event.preventDefault()\"\n        tabindex=\"-1\"\n        class=\"ui-spinner-button ui-spinner-up ui-corner-tr ui-button ui-widget ui-state-default\"\n      >\n        <span class=\"ui-spinner-button-icon pi pi-caret-up ui-clickable\"></span>\n      </button>\n      <button\n        (mousedown)=\"onSpinDown(input, $event)\"\n        (click)=\"$event.preventDefault()\"\n        tabindex=\"-1\"\n        class=\"ui-spinner-button ui-spinner-down ui-corner-br ui-button ui-widget ui-state-default\"\n      >\n        <span\n          class=\"ui-spinner-button-icon pi pi-caret-down ui-clickable\"\n        ></span>\n      </button>\n    </span>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return NumericComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return NumericComponent_1; })
                }
            ]
        })
    ], NumericComponent);
    return NumericComponent;
}(template_form_1.InputComponent));
exports.NumericComponent = NumericComponent;
var NumericModule = /** @class */ (function () {
    function NumericModule() {
    }
    NumericModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, shared_1.SharedModule],
            declarations: [NumericComponent],
            exports: [NumericComponent]
        })
    ], NumericModule);
    return NumericModule;
}());
exports.NumericModule = NumericModule;
