"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var fileupload_1 = require("primeng/fileupload");
var UploadComponent = /** @class */ (function () {
    function UploadComponent() {
        this.style = {};
        this.multiple = false;
        this.showCancelButton = true;
        this.showUploadButton = true;
        this.auto = false;
        this.previewWidth = 50;
        this.chooseText = 'Choose';
        this.uploadText = 'Upload';
        this.cancelText = 'Cancel';
        this.parameterName = 'file';
        this.mode = 'advanced';
        this.beforeUpload = new core_1.EventEmitter();
        this.beforeSend = new core_1.EventEmitter();
        this.upload = new core_1.EventEmitter();
        this.error = new core_1.EventEmitter();
        this.clear = new core_1.EventEmitter();
        this.cancel = new core_1.EventEmitter();
    }
    UploadComponent.prototype.onBeforeUpload = function (event) {
        this.beforeUpload.next(event);
    };
    UploadComponent.prototype.onBeforeSend = function (event) {
        this.beforeSend.next(event);
    };
    UploadComponent.prototype.onUpload = function (event) {
        this.upload.next(event);
    };
    UploadComponent.prototype.onCustomUpload = function (event) {
        var _this = this;
        if (Array.isArray(event.files)) {
            Promise.all(event.files.map(function (file) {
                return new Promise(function (resolve, reject) {
                    var reader = new FileReader();
                    reader.onload = function (event) {
                        file.dataURL = event.target.result;
                        file.base64 = file.dataURL.replace(/data:[^,]+,/, '');
                        resolve();
                    };
                    reader.onerror = reject;
                    reader.readAsDataURL(file);
                });
            })).then(function () {
                _this.upload.next(event);
                if (_this.mode == 'basic') {
                    _this.fileUpload.clear();
                }
            });
        }
    };
    UploadComponent.prototype.onError = function (event) {
        this.error.next(event);
    };
    UploadComponent.prototype.onClear = function (event) {
        this.clear.next(event);
    };
    UploadComponent.prototype.onCancel = function (event) {
        this.cancel.next(event);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "url", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "showCancelButton", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "showUploadButton", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "auto", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "maxFileSize", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "accept", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "previewWidth", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "chooseText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "uploadText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "cancelText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "parameterName", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], UploadComponent.prototype, "mode", void 0);
    __decorate([
        core_1.ViewChild(fileupload_1.FileUpload),
        __metadata("design:type", fileupload_1.FileUpload)
    ], UploadComponent.prototype, "fileUpload", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "beforeUpload", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "beforeSend", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "upload", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "error", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "clear", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], UploadComponent.prototype, "cancel", void 0);
    UploadComponent = __decorate([
        core_1.Component({
            selector: 'rz-upload',
            template: "\n    <p-fileUpload\n      [name]=\"parameterName\"\n      [style]=\"style\"\n      [url]=\"url\"\n      [mode]=\"mode\"\n      [multiple]=\"multiple\"\n      [customUpload]=\"!url\"\n      [auto]=\"auto\"\n      [maxFileSize]=\"maxFileSize\"\n      [accept]=\"accept\"\n      [previewWidth]=\"previewWidth\"\n      [showCancelButton]=\"showCancelButton\"\n      [showUploadButton]=\"showUploadButton\"\n      [chooseLabel]=\"chooseText\"\n      [uploadLabel]=\"uploadText\"\n      [cancelLabel]=\"cancelText\"\n      (onBeforeUpload)=\"onBeforeUpload($event)\"\n      (onBeforeSend)=\"onBeforeSend($event)\"\n      (onUpload)=\"onUpload($event)\"\n      (onError)=\"onError($event)\"\n      (onClear)=\"onClear($event)\"\n      (onCancel)=\"onCancel($event)\"\n      (uploadHandler)=\"onCustomUpload($event)\"\n    ></p-fileUpload>\n  "
        })
    ], UploadComponent);
    return UploadComponent;
}());
exports.UploadComponent = UploadComponent;
var UploadModule = /** @class */ (function () {
    function UploadModule() {
    }
    UploadModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, fileupload_1.FileUploadModule],
            declarations: [UploadComponent],
            exports: [UploadComponent]
        })
    ], UploadModule);
    return UploadModule;
}());
exports.UploadModule = UploadModule;
