"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var rimraf = require("rimraf");
var path_1 = require("path");
var Ignore = require('ignore');
var child_process = require("child_process");
var lodash_1 = require("lodash");
var dotenv = require("dotenv");
var merge_project_1 = require("./merge-project");
var Component_1 = require("./Component");
var Event_1 = require("./Event");
var Application_1 = require("./Application");
var DataSource_1 = require("./DataSource");
var env = require("./env");
var renderTemplate_1 = require("./renderTemplate");
var fs_1 = require("./fs");
var securityDataSource_1 = require("./securityDataSource");
var fs_2 = require("fs");
var semver_1 = require("semver");
__export(require("./toolbox"));
__export(require("./build"));
__export(require("./deploy"));
__export(require("./securityDataSource"));
function updateFile(path, content, mergeContent) {
    return fs_1.fileExists(path)
        .then(function (exists) {
        return exists ? fs_1.readFile(path) : null;
    })
        .then(function (original) {
        if (original != content) {
            if (original && mergeContent && path.endsWith('.json')) {
                var originalContentAsJSON = JSON.parse(original);
                lodash_1.merge(originalContentAsJSON, JSON.parse(content));
                return fs_1.writeFile(path, JSON.stringify(originalContentAsJSON, null, 2));
            }
            return fs_1.writeFile(path, content);
        }
    });
}
function styles(application) {
    return [];
}
exports.styles = styles;
function initDesignTime() {
    return Promise.resolve({
        destroy: function () { }
    });
}
exports.initDesignTime = initDesignTime;
function copyThemeDir(path, source, name, application) {
    if (name == 'fonts') {
        return fs_1.cp(source, path_1.join(path, 'server', 'wwwroot', 'assets', name), createIgnore(path, application));
    }
    else {
        return Promise.resolve(true);
    }
}
exports.copyThemeDir = copyThemeDir;
function customThemePath() {
    return path_1.join('server', 'wwwroot', 'assets', 'css');
}
exports.customThemePath = customThemePath;
function copyAssets(path, source, application) {
    return fs_1.cp(source, path_1.join(path, 'server', 'wwwroot', 'assets'), createIgnore(path, application));
}
exports.copyAssets = copyAssets;
function setConfigValue(path, key, value) {
    var file = path_1.join(path, '.env');
    return fs_1.readFile(file)
        .then(function (data) {
        return dotenv.parse(data);
    }, function () { return ({}); })
        .then(function (config) {
        config[key] = value;
        var lines = Object.keys(config).map(function (key) {
            return key + "=\"" + config[key] + "\"";
        });
        return fs_1.writeFile(file, lines.join('\n'));
    });
}
exports.setConfigValue = setConfigValue;
function getConfigValue(path, key, sync) {
    if (sync === void 0) { sync = false; }
    var file = path_1.join(path, '.env');
    if (sync) {
        if (fs.existsSync(file)) {
            var data = fs_2.readFileSync(file);
            var config = dotenv.parse(data);
            return config[key];
        }
        else {
            return null;
        }
    }
    else {
        return fs_1.readFile(file).then(function (data) {
            var config = dotenv.parse(data);
            return config[key];
        }, function () { return null; });
    }
}
exports.getConfigValue = getConfigValue;
function getConnectionString(path, key, sync) {
    if (sync === void 0) { sync = false; }
    return getConfigValue(path, "ConnectionStrings__" + key, sync);
}
exports.getConnectionString = getConnectionString;
function setConnectionString(path, key, value) {
    return setConfigValue(path, "ConnectionStrings__" + key, value);
}
exports.setConnectionString = setConnectionString;
function getDeployData(path, dataFile) {
    var file = dataFile || path_1.join(path, '.settings');
    return fs_1.fileExists(file).then(function (exists) {
        return exists
            ? fs_1.readFile(file).then(function (data) { return JSON.parse(data)['deploy']; })
            : null;
    });
}
exports.getDeployData = getDeployData;
function setDeployData(path, value, dataFile) {
    var file = dataFile || path_1.join(path, '.settings');
    return updateFile(file, JSON.stringify({ deploy: value }));
}
exports.setDeployData = setDeployData;
function saveSSL(path, key, cert, pfx, application) {
    var client = fs_1.ensure(path, 'client');
    var server = fs_1.ensure(path, 'server');
    var ssl = fs_1.ensure(client, 'ssl');
    var ignore = createIgnore(path, application);
    return Promise.all([
        writeFileOnce(path_1.join(ssl, 'server.key'), key, ignore),
        writeFileOnce(path_1.join(ssl, 'server.crt'), cert, ignore),
        writeFileOnce(path_1.join(server, 'server.pfx'), pfx, ignore, { encoding: 'binary' })
    ]);
}
exports.saveSSL = saveSSL;
function createIgnore(appPath, application) {
    var ignore = function (path) { return false; };
    if (Array.isArray(application.ignore)) {
        var matcher_1 = Ignore();
        matcher_1.add(application.ignore.map(function (pattern) { return pattern.split('\\').join('/'); }));
        ignore = function (path) {
            return matcher_1.ignores(path_1.relative(appPath, path));
            /*
            const result = matcher.ignores(relative(appPath, path));
      
            if (result) {
              console.log('Ignored: ', relative(appPath, path));
            }
      
            return result;
            */
        };
    }
    return ignore;
}
function generatePage(path, application, page) {
    var dataSources = application.dataSources.map(function (dataSource) {
        return DataSource_1.swaggerToDataSource(dataSource, application.https, null, null);
    });
    var server = fs_1.ensure(path, 'server');
    var pagesDir = fs_1.ensure(server, 'Pages');
    var ignore = createIgnore(path, application);
    return outputPage(pagesDir, application, page, dataSources, null, pageParameters(application.pages), ignore);
}
exports.generatePage = generatePage;
function generateLayout(path, application, page) {
    var dataSources = application.dataSources.map(function (dataSource) {
        return DataSource_1.swaggerToDataSource(dataSource, application.https, null, null);
    });
    var server = fs_1.ensure(path, 'server');
    var pagesDir = fs_1.ensure(server, 'Shared');
    var ignore = createIgnore(path, application);
    return outputLayout(pagesDir, application, page, dataSources, null, ignore);
}
exports.generateLayout = generateLayout;
function ensureSecurityConfiguration(application) {
    if (application.security) {
        if (!application.security.loginPage) {
            throw new Error('Radzen: Security is enabled but no login page is specified.');
        }
        var loginPage = application.pages.find(function (page) { return page.name == application.security.loginPage; });
        if (!loginPage) {
            throw new Error("Radzen: Cannot find " + application.security.loginPage + " which is specified as the login page.");
        }
        var _a = loginPage.access, access = _a === void 0 ? [] : _a;
        if (!Array.isArray(access)) {
            access = [access];
        }
        if (access.indexOf('Everybody') < 0) {
            throw new Error("Radzen: The application login page (\"" + loginPage.name + "\") does not allow access to anonymous users. Open the \"" + loginPage.name + "\" properties and add \"Everybody\" to the access list.");
        }
    }
}
function generate(path, application, isRunning, mode, options) {
    if (isRunning === void 0) { isRunning = false; }
    ensureSecurityConfiguration(application);
    try {
        var result = child_process.execSync('dotnet --version');
        var versionNeeded = '3.1.100';
        var version = result.toString().trim();
        // console.log(version, versionNeeded);
        if (semver_1.gt(versionNeeded, version)) {
            throw new Error("Radzen: .NET Version Mismatch " + versionNeeded + " " + version);
        }
    }
    catch (err) {
        if (/^Radzen:/.test(err.message)) {
            throw err;
        }
    }
    var dataSources = application.dataSources.map(function (d) {
        var runtimePath = null;
        var endPoint = null;
        if (mode == 'deploy') {
            if (d.info['x-connector']) {
                runtimePath = "" + (options.baseHref == '/' || !options.baseHref ? '' : options.baseHref) + d.basePath;
            }
            else {
                var value = options.endPoints[d.info.title].value;
                endPoint = value;
            }
        }
        return DataSource_1.swaggerToDataSource(d, application.https, runtimePath, endPoint);
    });
    var pages = application.pages, _a = application.layouts, layouts = _a === void 0 ? [] : _a;
    var server = fs_1.ensure(path, 'server');
    var services = fs_1.ensure(server, 'Services');
    var shared = fs_1.ensure(server, 'Shared');
    var pagesDir = fs_1.ensure(server, 'Pages');
    var controllersDir = fs_1.ensure(server, 'Controllers');
    var wwwroot = fs_1.ensure(server, 'wwwroot');
    var assets = fs_1.ensure(wwwroot, 'assets');
    var css = fs_1.ensure(assets, 'css');
    var ignore = createIgnore(path, application);
    var needsAccountController = application.security || dataSources.some(dataSourceHasSecurity);
    return Promise.all([
        copyFileOnce(path, '.gitignore', '.gitignore', ignore),
        copyFileOnce(wwwroot, 'favicon.ico', 'favicon.ico', ignore),
        writeTemplate(path_1.join(css, 'styles-generated.css'), 'styles-generated.css.ejs', { application: application, mode: mode, options: options }, ignore),
        writeTemplateOnce(path_1.join(css, 'styles.css'), 'styles.css.ejs', application, ignore),
        writeTemplateOnce(path_1.join(controllersDir, 'UploadController.cs'), 'UploadController.cs.ejs', { application: application }, ignore),
        writeServerTemplate(application, path_1.join(controllersDir, 'ReportController.cs'), 'ReportController.cs.ejs', { application: application }, ignore),
        writeTemplate(path_1.join(pagesDir, '_Host.cshtml'), '_Host.cshtml.ejs', {
            application: application
        }, ignore),
        writeTemplate(path_1.join(server, "App.razor"), 'App.razor.ejs', {
            application: application,
            dataSources: dataSources
        }, ignore),
        application.security &&
            writeTemplate(path_1.join(shared, "RedirectToLogin.razor"), 'RedirectToLogin.razor.ejs', {
                application: application,
                dataSources: dataSources
            }, ignore),
        writeTemplate(path_1.join(server, "Dockerfile"), 'Dockerfile.ejs', {
            application: application,
            dataSources: dataSources,
            env: env
        }, ignore),
        outputProjectFile(server, application, dataSources, ignore),
        mode != 'deploy' &&
            writeTemplateOnce(path_1.join(path, env.type(application.name) + ".sln"), 'application.sln.ejs', { application: application, env: env }, ignore),
        writeTemplate(path_1.join(server, '_Imports.razor'), '_Imports.razor.ejs', {
            application: application
        }, ignore),
        writeTemplate(path_1.join(server, 'Program.cs'), 'Program.cs.ejs', {
            application: application,
            dataSources: dataSources
        }, ignore),
        writeTemplate(path_1.join(server, 'Startup.cs'), 'Startup.cs.ejs', {
            application: application,
            dataSources: dataSources,
            dataSourceName: dataSourceName
        }, ignore),
        writeTemplate(path_1.join(controllersDir, 'ExportController.cs'), 'ExportController.cs.ejs', {
            application: application
        }, ignore),
        !application.localization &&
            fs.existsSync(path_1.join(controllersDir, 'CultureController.cs')) &&
            fs.unlinkSync(path_1.join(controllersDir, 'CultureController.cs')),
        fs.existsSync(path_1.join(services, 'Query.cs')) &&
            fs.unlinkSync(path_1.join(services, 'Query.cs')),
        !application.localization && rimraf.sync(path_1.join(server, '**', '*.resx')),
        !application.security &&
            fs.existsSync(path_1.join(services, 'SecurityService.cs')) &&
            fs.unlinkSync(path_1.join(services, 'SecurityService.cs')),
        !application.security &&
            fs.existsSync(path_1.join(shared, 'RedirectToLogin.razor')) &&
            fs.unlinkSync(path_1.join(shared, 'RedirectToLogin.razor')),
        !application.security &&
            fs.existsSync(path_1.join(server, 'Authentication', 'ApplicationPrincipalFactory.cs')) &&
            fs.unlinkSync(path_1.join(server, 'Authentication', 'ApplicationPrincipalFactory.cs')),
        !application.security &&
            fs.existsSync(path_1.join(server, 'Authentication')) &&
            rimraf.sync(path_1.join(server, 'Authentication')),
        !needsAccountController &&
            fs.existsSync(path_1.join(controllersDir, 'AccountController.cs')) &&
            fs.unlinkSync(path_1.join(controllersDir, 'AccountController.cs')),
        !application.security &&
            fs.existsSync(path_1.join(server, 'Models', 'ApplicationUser.cs')) &&
            fs.unlinkSync(path_1.join(server, 'Models', 'ApplicationUser.cs')),
        !application.security &&
            fs.existsSync(path_1.join(server, 'Data', 'ApplicationIdentityDbContext.cs')) &&
            fs.unlinkSync(path_1.join(server, 'Data', 'ApplicationIdentityDbContext.cs')),
        !application.security &&
            fs.existsSync(path_1.join(server, 'Data', 'Migrations')) &&
            rimraf.sync(path_1.join(server, 'Data', 'Migrations')),
        Application_1.isDefault(application.security) &&
            writeTemplate(path_1.join(services, 'SecurityService.cs'), 'SecurityService.cs.ejs', {
                application: application,
                dataSources: dataSources,
                dataSourceName: dataSourceName
            }, ignore),
        Application_1.isActiveDirectory(application.security) &&
            writeTemplate(path_1.join(services, 'SecurityService.cs'), 'ActiveDirectorySecurityService.cs.ejs', {
                application: application,
                dataSources: dataSources,
                dataSourceName: dataSourceName
            }, ignore),
        application.localization &&
            writeTemplate(path_1.join(controllersDir, 'CultureController.cs'), 'CultureController.cs.ejs', {
                application: application,
                dataSources: dataSources,
                dataSourceName: dataSourceName
            }, ignore),
        needsAccountController &&
            writeTemplate(path_1.join(controllersDir, 'AccountController.cs'), 'AccountController.cs.ejs', {
                application: application,
                dataSources: dataSources,
                dataSourceName: dataSourceName
            }, ignore),
        writeTemplate(path_1.join(fs_1.ensure(server, 'Properties'), 'launchSettings.json'), 'launchSettings.json.ejs', {
            application: application,
            dataSources: dataSources,
            dataSourceName: dataSourceName
        }, ignore),
        writeTemplate(path_1.join(pagesDir, '_Imports.razor'), '_Imports.Pages.razor.ejs', { application: application }, ignore),
        outputDataSources(services, controllersDir, application, dataSources, ignore),
        // Pages
        outputPages(pagesDir, application, pages, dataSources, mode == 'deploy' ? options : null, ignore),
        outputLayouts(shared, application, layouts, dataSources, mode == 'deploy' ? options : null, ignore),
        // Server
        outputDataServices(path, server, application, dataSources, isRunning, mode, options, ignore)
    ]);
}
exports.generate = generate;
function restorePackages(cwd, env, onStart) {
    console.log('dotnet: ', 'Restoring packages ...');
    return new Promise(function (resolve, reject) {
        var child = child_process.spawn('dotnet', ['restore'], { cwd: cwd, env: env });
        onStart(child);
        child.on('error', reject);
        child.on('exit', function (code) {
            if (typeof code != 'number') {
                // stopped by user
                resolve(false);
            }
            else if (code > 0) {
                // exit with error
                reject();
            }
            else {
                // exit successfully
                resolve(true);
            }
        });
        child.stderr.on('data', function (data) {
            console.log('dotnet:', data.toString());
        });
        child.stdout.on('data', function (data) {
            console.log('dotnet:', data.toString());
        });
    });
}
function startServer(_a) {
    var command = _a.command, serverVersion = _a.serverVersion, options = _a.options, successMessage = _a.successMessage, directory = _a.directory, onStart = _a.onStart, onError = _a.onError, onExit = _a.onExit, onSuccess = _a.onSuccess;
    var cwd = path_1.join(directory, 'server');
    var success = false;
    var env = Object.assign({
        ASPNETCORE_ENVIRONMENT: 'Development',
        RADZEN: true,
        UseRazorBuildServer: false,
        UseSharedCompilation: false
    }, process.env);
    if (env.hasOwnProperty('Path') && env.hasOwnProperty('PATH')) {
        delete env.Path;
    }
    var args = command == 'run' ? ['watch', command, options] : [command, options];
    var child = child_process.spawn('dotnet', args, { cwd: cwd, env: env });
    onStart(child);
    child.on('error', onError);
    child.on('exit', function (code) {
        if (code > 0) {
            onError();
        }
        else {
            onExit();
        }
    });
    child.stderr.on('data', function (data) {
        console.log('dotnet:', data.toString());
    });
    child.stdout.on('data', function (data) {
        var message = data.toString();
        console.log('dotnet:', message);
        if (message.includes(successMessage) && !success) {
            success = true;
            onSuccess();
        }
    });
}
exports.startServer = startServer;
function supportsServer() {
    var _this = this;
    return new Promise(function (resolve, reject) {
        if (process.platform == 'win32') {
            child_process.exec('dotnet --version', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                var sdks;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (err) {
                                console.error(err);
                                return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                            }
                            return [4 /*yield*/, installedDotNetCoreSDKs()];
                        case 1:
                            sdks = _a.sent();
                            resolve(sdks);
                            return [2 /*return*/];
                    }
                });
            }); });
        }
        else if (process.platform == 'darwin') {
            child_process.exec('ls /usr/local/share/dotnet/shared/Microsoft.NETCore.App/', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (err) {
                        console.error(err);
                        return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                    }
                    resolve(stdout.split('\n'));
                    return [2 /*return*/];
                });
            }); });
        }
        else {
            child_process.exec('dotnet --version', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (err) {
                        console.error(err);
                        return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                    }
                    resolve([stdout.trim()]);
                    return [2 /*return*/];
                });
            }); });
        }
    });
}
exports.supportsServer = supportsServer;
function interpolateParameterAsCode(parameter, value) {
    return env.interpolateParameterAsCode(parameter, value);
}
exports.interpolateParameterAsCode = interpolateParameterAsCode;
function dotnetType(property, lang) {
    if (lang === void 0) { lang = 'cs'; }
    return env.dotnetType(property, lang);
}
exports.dotnetType = dotnetType;
function installedDotNetCoreSDKs() {
    return __awaiter(this, void 0, void 0, function () {
        var relativePath, dotnet64Path, path32, dotnet32Path, dotnetPath, _a, sdks;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    relativePath = 'dotnet/sdk';
                    dotnet64Path = path_1.resolve(path_1.join(process.env.ProgramFiles, relativePath));
                    path32 = process.env['ProgramFiles(x86)'];
                    dotnet32Path = path32 ? path_1.resolve(path_1.join(path32, relativePath)) : null;
                    if (fs.existsSync(dotnet64Path)) {
                        dotnetPath = dotnet64Path;
                    }
                    else if (dotnet32Path && fs.existsSync(dotnet32Path)) {
                        dotnetPath = dotnet32Path;
                    }
                    _a = dotnetPath;
                    if (!_a) return [3 /*break*/, 2];
                    return [4 /*yield*/, fs_1.dirExists(dotnetPath)];
                case 1:
                    _a = (_b.sent());
                    _b.label = 2;
                case 2:
                    if (!_a) return [3 /*break*/, 4];
                    return [4 /*yield*/, fs_1.readdir(dotnetPath)];
                case 3:
                    sdks = _b.sent();
                    return [2 /*return*/, sdks.filter(function (i) { return i != 'NuGetFallbackFolder'; })];
                case 4: return [2 /*return*/, []];
            }
        });
    });
}
function getPathByLanguage(application, path) {
    return (application.serverVersion == '2' ||
        application.serverVersion == '3') &&
        application.serverLang == 'vb'
        ? path.replace('.cs', '.vb')
        : path;
}
function getServerTemplate(application, path) {
    return application.serverVersion == '2' || application.serverVersion == '3'
        ? path_1.join('core2', getPathByLanguage(application, path))
        : path;
}
function writeServerTemplate(application, path, template, data, ignore, merge) {
    if (ignore(path)) {
        return;
    }
    if ((application.serverVersion == '2' || application.serverVersion == '3') &&
        application.serverLang == 'vb' &&
        path.indexOf('.cshtml') != -1) {
        return Promise.resolve();
    }
    if (application.serverVersion != '2' &&
        application.serverVersion != '3' &&
        path.indexOf('OutputFormatter.cs') != -1) {
        return Promise.resolve();
    }
    path = getPathByLanguage(application, path);
    return renderTemplate_1.renderTemplate(getServerTemplate(application, template), data).then(function (output) { return updateFile(path, output, merge); });
}
function dataSourceName(name) {
    return name.indexOf(' ') != -1 ||
        name.indexOf('_') != -1 ||
        name.indexOf('-') != -1
        ? env.pascalCase(name)
        : name;
}
function outputDataSources(path, controllersPath, application, services, ignore) {
    fs_1.ensure(path);
    return Promise.all(services.map(function (service) {
        return outputService(path, controllersPath, application, service, ignore);
    }).slice());
}
function outputService(path, controllersPath, application, service, ignore) {
    return Promise.all([
        writeService(path, controllersPath, application, service, ignore)
    ]);
}
function writeService(path, controllersPath, application, service, ignore) {
    var template;
    if (service.type == 'rest') {
        template = 'rest.service.cs.ejs';
    }
    else if (service.type == 'odata' && !service.connector) {
        template = 'odata.service.cs.ejs';
    }
    else {
        template = 'service.cs.ejs';
    }
    if (service.type == 'rest' || (service.type == 'odata' && !service.connector)) {
        return Promise.all([
            writeTemplate(path_1.join(path, env.pascalCase(service.name) + "Service.cs"), template, Object.assign({ security: application.security }, service, { application: application }, { upperFirst: lodash_1.upperFirst, camelCase: lodash_1.camelCase, get: lodash_1.get }), ignore)
        ]);
    }
    else {
        return Promise.all([
            writeTemplate(path_1.join(path, env.pascalCase(service.name) + "Service.cs"), template, Object.assign({ security: application.security }, service, { application: application }, { upperFirst: lodash_1.upperFirst, camelCase: lodash_1.camelCase, get: lodash_1.get }), ignore),
            writeTemplate(path_1.join(controllersPath, "Export" + env.pascalCase(service.name) + "Controller.cs"), 'ExportDataController.cs.ejs', Object.assign({ security: application.security }, service, { application: application }, { upperFirst: lodash_1.upperFirst, camelCase: lodash_1.camelCase, get: lodash_1.get }), ignore)
        ]);
    }
}
function dataSourceHasSecurity(dataSource) {
    return (dataSource.authorization &&
        /oauth|azuread/.test(dataSource.authorization.type));
}
function generateDataSource(path, application, swagger) {
    var dataSource = DataSource_1.swaggerToDataSource(swagger, false);
    var ignore = createIgnore(path, application);
    var server = fs_1.ensure(path, 'server');
    fs_1.ensure(server);
    fs_1.ensure(path_1.join(server, 'Models'));
    fs_1.ensure(path_1.join(server, 'Data'));
    var services = fs_1.ensure(path_1.join(server, 'Services'));
    var controllersDir = fs_1.ensure(path_1.join(server, 'Controllers'));
    var service = outputService(services, controllersDir, application, dataSource, ignore);
    var promises = [service];
    if (dataSource.type == 'odata' && dataSource.connector) {
        var model = outputDataModels(server, application, dataSource, ignore);
        var context = outputODataContext(server, application, dataSource, ignore);
        promises.push(model, context);
    }
    else {
        var model = outputRestModels(server, application, dataSource, ignore);
        if (dataSource.type == 'odata') {
            var enums = outputODataEnums(server, application, dataSource, ignore);
            promises.push(enums);
        }
        promises.push(model);
        if (dataSourceHasSecurity(dataSource)) {
            var handler = outputOAuthHttpHandler(server, application, dataSource, ignore);
            promises.push(handler);
        }
    }
    return Promise.all(promises);
}
exports.generateDataSource = generateDataSource;
function outputDataServices(appPath, path, application, dataSources, isRunning, mode, options, ignore) {
    var sqlDataSources = dataSources.filter(function (dataSource) { return dataSource.connector; });
    var restDataSources = dataSources.filter(function (dataSource) { return dataSource.type == 'rest' || (dataSource.type == 'odata' && !dataSource.connector); });
    var dataSourcesWithSecurity = dataSources.filter(dataSourceHasSecurity);
    sqlDataSources.forEach(function (dataSource) {
        var connectionString = getConnectionString(appPath, dataSourceName(dataSource.name) + "Connection", true);
        if (!connectionString && process.env.NODE_ENV == 'production') {
            throw new Error("Radzen: Connection info for the " + dataSource.name + " data source is missing.");
        }
    });
    if (application.serverProject) {
        fs_1.ensure(path);
        fs_1.ensure(path_1.join(path, 'Models'));
        fs_1.ensure(path_1.join(path, 'Data'));
        if ((application.serverVersion == '2' || application.serverVersion == '3') &&
            mode != 'deploy') {
            fs_1.ensure(path_1.join(path, 'Properties'));
        }
        var models = sqlDataSources.map(function (dataSource) {
            return outputDataModels(path, application, dataSource, ignore);
        });
        var restModels = restDataSources.map(function (dataSource) {
            return outputRestModels(path, application, dataSource, ignore);
        });
        var odataEnums = restDataSources.map(function (dataSource) {
            return outputODataEnums(path, application, dataSource, ignore);
        });
        var contexts = sqlDataSources.map(function (dataSource) {
            return outputODataContext(path, application, dataSource, ignore);
        });
        var oauthHttpHandlers = dataSourcesWithSecurity.map(function (dataSource) {
            return outputOAuthHttpHandler(path, application, dataSource, ignore);
        });
        return Promise.all(models.concat(restModels, odataEnums, contexts, oauthHttpHandlers, [
            application.security
                ? outputServerSecurity(path, application, mode, options, ignore)
                : Promise.resolve(true),
            writeServerTemplate(application, path_1.join(path, 'appsettings.json'), 'appsettings.json.ejs', {
                application: application,
                dataSources: sqlDataSources,
                dataSourcesWithSecurity: dataSourcesWithSecurity,
                appPath: appPath,
                getConnectionString: getConnectionString,
                dataSourceName: dataSourceName
            }, ignore, true)
        ]));
    }
    else if (Application_1.isActiveDirectory(application.security)) {
        fs_1.ensure(path);
        fs_1.ensure(path_1.join(path, 'Models'));
        return Promise.all([
            application.security
                ? outputServerSecurity(path, application, mode, options, ignore)
                : Promise.resolve(true),
            writeServerTemplate(application, path_1.join(path, 'appsettings.json'), 'appsettings.json.ejs', {
                application: application,
                dataSources: sqlDataSources,
                appPath: appPath,
                getConnectionString: getConnectionString,
                dataSourceName: dataSourceName
            }, ignore, true)
        ]);
    }
}
function outputProjectFile(path, application, dataSources, ignore) {
    var targetPath = path_1.join(path, env.type(application.name) + ".csproj");
    if (ignore(targetPath)) {
        return;
    }
    return fs_1.fileExists(targetPath)
        .then(function (exists) {
        if (exists) {
            return fs_1.readFile(targetPath, 'utf8');
        }
        else {
            return '';
        }
    })
        .then(function (targetXML) {
        return renderTemplate_1.renderTemplate('project.csproj.ejs', {
            application: application,
            dataSources: dataSources
        }).then(function (sourceXML) { return merge_project_1.mergeProject(sourceXML, targetXML); });
    })
        .then(function (xml) { return fs_1.writeFile(targetPath, xml); });
}
function outputServerSecurity(path, application, mode, options, ignore) {
    var authenticationPath = path_1.join(path, 'Authentication');
    fs_1.ensure(authenticationPath);
    var roles = lodash_1.uniq(lodash_1.flatten(application.pages.map(function (page) { return page.access; })).filter(function (access) { return access != 'Everybody' && access != 'Authenticated'; }));
    if (Application_1.isDefault(application.security)) {
        return Promise.all([
            outputIdentityMigrations(path, application, ignore),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderMiddleware.cs'))),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderAppBuilderExtensions.cs'))),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationPrincipalFactory.cs'), 'ApplicationPrincipalFactory.cs.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'Bootstrapper.cs'))),
            writeServerTemplate(application, path_1.join(path, 'Models', 'ApplicationUser.cs'), 'ApplicationUser.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Data', 'ApplicationIdentityDbContext.cs'), 'ApplicationIdentityDbContext.cs.ejs', { application: application }, ignore)
        ]);
    }
    if (Application_1.isActiveDirectory(application.security)) {
        return Promise.all([
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserManager.cs'), 'ApplicationUserManager.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserManagerOptions.cs'), 'ApplicationUserManagerOptions.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserStore.cs'), 'ApplicationUserStore.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationRoleStore.cs'), 'ApplicationRoleStore.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Models', 'ApplicationUser.cs'), 'ApplicationUser.cs.ejs', { application: application }, ignore)
        ]);
    }
}
function outputIdentityMigrations(path, application, ignore) {
    path = path_1.join(path, 'Data', 'Migrations');
    fs_1.ensure(path);
    return Promise.all([
        writeTemplateUnlessContains(application, path_1.join(path, 'IdentityModelSnapshot.cs'), getServerTemplate(application, 'IdentityModelSnapshot.cs.ejs'), 'ApplicationUser', { application: application }, ignore),
        writeServerTemplate(application, path_1.join(path, '00000000000000_CreateIdentitySchema.cs'), '00000000000000_CreateIdentitySchema.cs.ejs', { application: application }, ignore),
        writeServerTemplate(application, path_1.join(path, '00000000000000_CreateIdentitySchema.Designer.cs'), '00000000000000_CreateIdentitySchema.Designer.cs.ejs', { application: application }, ignore)
    ]);
}
function outputProgram(path, application, mode, ignore) {
    return writeServerTemplate(application, path_1.join(path, 'Program.cs'), 'program.cs.ejs', {
        application: application,
        mode: mode
    }, ignore);
}
function outputDataModels(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Models', dataSource.name);
    fs_1.ensure(path);
    return Promise.all(dataSource.schemas
        .filter(function (m) { return env.validModel(m); })
        .map(function (schema) {
        return outputDataModel(path, application, schema, dataSource, ignore);
    }));
}
function outputODataEnums(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Models', dataSource.name);
    fs_1.ensure(path);
    return Promise.all(dataSource.enums
        .map(function (e) {
        return outputODataEnum(path, application, e, dataSource, ignore);
    }));
}
function outputRestModels(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Models', env.type(dataSource.name));
    fs_1.ensure(path);
    return Promise.all(dataSource.schemas.map(function (schema) {
        return outputRestModel(path, application, schema, dataSource, ignore);
    }));
}
function outputOAuthHttpHandler(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Services');
    fs_1.ensure(path);
    return writeTemplate(path_1.join(path, env.type(dataSource.name) + "HttpHandler.cs"), 'oauth.http.handler.cs.ejs', {
        dataSource: dataSource,
        application: application
    }, ignore);
}
function outputODataControllers(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Controllers', dataSource.name);
    fs_1.ensure(path);
    return Promise.all(dataSource.schemas
        .filter(env.validModel)
        .map(function (schema) {
        return outputODataController(path, application, schema, dataSource, ignore);
    }));
}
function outputODataEnum(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.name + ".cs"), 'odata.enum.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource
    }, ignore);
}
function outputDataModel(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.name + ".cs"), 'model.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource
    }, ignore);
}
function outputRestModel(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.name + ".cs"), dataSource.type == 'odata' ? 'odata.model.cs.ejs' : 'rest.model.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource
    }, ignore);
}
function deleteODataModel(path, model, ext, ignore) {
    return safeDelete(path_1.join(path_1.join(path, model.name + "." + ext)), ignore);
}
function deleteODataController(path, model, ext, ignore) {
    return safeDelete(path_1.join(path, model.entitySet + "Controller." + ext), ignore);
}
function safeDelete(path, ignore) {
    if (!ignore(path)) {
        return fs_1.rm(path);
    }
}
function outputODataController(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.entitySet + "Controller.cs"), 'controller.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource
    }, ignore);
}
function outputODataContext(path, application, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, 'Data', env.type(dataSource.name) + "Context.cs"), 'context.cs.ejs', {
        dataSource: dataSource,
        application: application
    }, ignore);
}
function designTimeHtml(application) {
    return renderTemplate_1.renderTemplate('app.component.html.ejs', Object.assign({ security: null }, application));
}
exports.designTimeHtml = designTimeHtml;
function setPageTitle(contentDocument, title) {
    contentDocument.querySelector('#title').innerHTML = title;
}
exports.setPageTitle = setPageTitle;
function setLogo(contentDocument, path, application) {
    if (application.logo) {
        var logo = contentDocument.querySelector('#logo img');
        var src = path_1.join(path, 'client', 'src', application.logo);
        logo.src = "file://" + src;
    }
}
exports.setLogo = setLogo;
function navigationContainerElement(contentDocument) {
    return contentDocument.querySelector('#navigation');
}
exports.navigationContainerElement = navigationContainerElement;
function contentElements(contentDocument) {
    return contentDocument.querySelectorAll('#content');
}
exports.contentElements = contentElements;
function copy(path, file, ignore, isRunning) {
    if (isRunning === void 0) { isRunning = false; }
    return copyFile(path, file, path_1.basename(file), ignore, isRunning);
}
function copyUnlessContains(path, file, value) {
    var templates = path_1.join(__dirname, './templates');
    var dest = path_1.join(path, path_1.basename(file));
    return fs_1.fileExists(dest)
        .then(function (exists) {
        if (exists) {
            // File exists - check if it contains the required value and overwrite otherwise.
            return fs_1.readFile(dest).then(function (contents) { return contents.indexOf(value) < 0; });
        }
        else {
            // File does not exist - create it.
            return true;
        }
    })
        .then(function (write) {
        if (write) {
            return new Promise(function (resolve, reject) {
                var reader = fs.createReadStream(path_1.join(templates, file));
                reader.on('error', reject);
                var writer = fs.createWriteStream(dest);
                writer.on('error', reject);
                reader.pipe(writer);
                resolve();
            });
        }
    });
}
function copyFile(path, file, target, ignore, isRunning) {
    if (isRunning === void 0) { isRunning = false; }
    var templates = path_1.join(__dirname, './templates');
    var dest = path_1.join(path, target);
    if (ignore(dest)) {
        return;
    }
    return fs_1.fileExists(dest)
        .then(function (exists) {
        return !(isRunning && exists);
    })
        .then(function (write) {
        if (write) {
            return new Promise(function (resolve, reject) {
                var reader = fs.createReadStream(path_1.join(templates, file));
                reader.on('error', reject);
                var writer = fs.createWriteStream(dest);
                writer.on('error', reject);
                reader.pipe(writer);
                resolve();
            });
        }
    });
}
function copyFileOnce(path, file, target, ignore) {
    return copyFile(path, file, target, ignore, true);
}
function deleteDataSource(path, name, swagger, application) {
    var ignore = createIgnore(path, application);
    var clientPath = path_1.join(path, 'client');
    var serverPath = path_1.join(path, 'server');
    var filename = env.file(name);
    var dataSource = DataSource_1.swaggerToDataSource(swagger, false);
    var models = dataSource.schemas.filter(env.validModel);
    var controllersPath = path_1.join(serverPath, 'Controllers', name);
    var deleteControllers = models.map(function (model) {
        return deleteODataController(controllersPath, model, 'cs', ignore);
    });
    var modelsPath = path_1.join(serverPath, 'Models', name);
    var deleteModels = models.map(function (model) {
        return deleteODataModel(modelsPath, model, 'cs', ignore);
    });
    return Promise.all(deleteModels.concat(deleteControllers, [
        safeDelete(path_1.join(serverPath, 'Services', env.pascalCase(name) + "Service.cs"), ignore),
        safeDelete(path_1.join(serverPath, 'Controllers', "Export" + env.pascalCase(name) + "Controller.cs"), ignore),
        safeDelete(path_1.join(serverPath, 'Data', filename.split('-').join('') + "Context.cs"), ignore),
        fs_1.dirExists(controllersPath).then(function (r) {
            return r &&
                fs_1.readdir(controllersPath).then(function (r) { return !r.length && fs_1.rm(controllersPath); });
        }),
        fs_1.dirExists(modelsPath).then(function (r) { return r && fs_1.readdir(modelsPath).then(function (r) { return !r.length && fs_1.rm(modelsPath); }); })
    ]));
}
exports.deleteDataSource = deleteDataSource;
function deletePage(path, name, cultures) {
    var resourcesToDelete = (cultures || []).map(function (c) {
        return fs_1.rm(path_1.join(path, 'server', 'Pages', env.pascalCase(name) + "." + c + ".resx"));
    });
    return Promise.all(resourcesToDelete.concat([
        fs_1.rm(path_1.join(path, 'server', 'Pages', env.pascalCase(name) + ".razor")),
        fs_1.rm(path_1.join(path, 'server', 'Pages', env.pascalCase(name) + ".razor.cs")),
        fs_1.rm(path_1.join(path, 'server', 'Pages', env.pascalCase(name) + ".razor.designer.cs"))
    ]));
}
exports.deletePage = deletePage;
function safeRename(from, to) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_1.fileExists(from)];
                case 1:
                    if (!_a.sent()) return [3 /*break*/, 3];
                    return [4 /*yield*/, fs_1.rename(from, to)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function renamePage(path, from, to) {
    return __awaiter(this, void 0, void 0, function () {
        var dir, fromComponent, toComponent, fromFileName, toFileName, text;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dir = path_1.join(path, 'server', 'Pages');
                    fromComponent = env.pascalCase(from);
                    toComponent = env.pascalCase(to);
                    fromFileName = path_1.join(dir, fromComponent);
                    toFileName = path_1.join(dir, toComponent);
                    return [4 /*yield*/, safeRename(fromFileName + ".razor.designer.cs", toFileName + ".razor.designer.cs")];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, safeRename(fromFileName + ".razor", toFileName + ".razor")];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, safeRename(fromFileName + ".razor.cs", toFileName + ".razor.cs")];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, fs_1.fileExists(toFileName + ".razor.cs")];
                case 4:
                    if (!_a.sent()) return [3 /*break*/, 7];
                    return [4 /*yield*/, fs_1.readFile(toFileName + ".razor.cs", 'utf8')];
                case 5:
                    text = _a.sent();
                    text = text.replace(new RegExp(fromComponent + "Component", 'g'), toComponent + "Component");
                    return [4 /*yield*/, fs_1.writeFile(toFileName + ".razor.cs", text, 'utf8')];
                case 6:
                    _a.sent();
                    _a.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.renamePage = renamePage;
function outputPages(path, application, pages, dataSources, options, ignore) {
    return Promise.all(pages.map(function (page) {
        return outputPage(path, application, page, dataSources, options, pageParameters(pages), ignore);
    }));
}
function outputLayouts(path, application, layouts, dataSources, options, ignore) {
    return Promise.all(layouts.map(function (layout) {
        return outputLayout(path, application, layout, dataSources, options, ignore);
    }));
}
function outputPage(path, application, page, dataSources, options, parameters, ignore) {
    return writePage(path, application, page, dataSources, options, false, ignore, parameters);
}
function outputLayout(path, application, layout, dataSources, options, ignore) {
    var page = __assign({}, layout, { name: layout.name + 'Layout' });
    return writePage(path, application, page, dataSources, options, true, ignore);
}
function traverse(events, callback) {
    function descend(actions) {
        return actions.reduce(function (result, action) {
            callback(result, action, descend);
            return result;
        }, []);
    }
    if (!events) {
        return [];
    }
    var actions = Object.keys(events).reduce(function (actions, key) {
        actions.push.apply(actions, events[key]);
        return actions;
    }, []);
    return descend(actions);
}
function setterNames(events) {
    function callback(result, action, traverse) {
        if (Event_1.isSet(action) &&
            action.name.indexOf('.') < 0 &&
            action.name.indexOf('[') < 0) {
            if (action.value && action.valueType) {
                result.push(action.valueType + ":" + action.name);
            }
            else if (action.value && action.value.includes('result.value')) {
                result.push('IEnumerable<dynamic>' + ":" + action.name);
            }
            else if (action.value &&
                (action.value.includes('odata.count') ||
                    action.value.includes('result.Count'))) {
                result.push('int' + ":" + action.name);
            }
            else {
                result.push(action.name);
            }
        }
        else {
            if (action.then) {
                result.push.apply(result, traverse(action.then));
            }
            if (action.error) {
                result.push.apply(result, traverse(action.error));
            }
        }
    }
    return traverse(events, callback);
}
function serviceNames(events) {
    function callback(result, action, traverse) {
        if (Event_1.isInvoke(action) || Event_1.isExport(action)) {
            if (action.name && action.name.includes('.')) {
                var service = action.name.split('.')[0];
                if (service != 'Security') {
                    result.push(service);
                }
            }
        }
        if (action.then) {
            result.push.apply(result, traverse(action.then));
        }
        if (action.error) {
            result.push.apply(result, traverse(action.error));
        }
    }
    return traverse(events, callback);
}
function dialogs(page) {
    var dialogs = [];
    function callback(result, action, traverse) {
        if (Event_1.isPopup(action)) {
            if (dialogs.indexOf(action.path) < 0) {
                dialogs.push(action.path);
            }
        }
        else {
            if (action.then) {
                traverse(action.then);
            }
            if (action.error) {
                traverse(action.error);
            }
        }
    }
    var events = Object.assign({}, page.events);
    traverseComponents(page, function (component) {
        if (component.events) {
            lodash_1.forEach(component.events, function (actions, name) {
                events[name] = actions.concat(events[name] || []);
            });
        }
    });
    traverse(events, callback);
    return dialogs;
}
function pageParameters(pages) {
    var parameters = {};
    function callback(result, action, traverse) {
        if ((Event_1.isPopup(action) || Event_1.isNavigate(action)) && action.parameters) {
            parameters[action.path] = action.parameters.map(function (parameter) { return parameter.name; });
        }
        else {
            if (action.then) {
                traverse(action.then);
            }
            if (action.error) {
                traverse(action.error);
            }
        }
    }
    pages.forEach(function (page) {
        var events = Object.assign({}, page.events);
        traverseComponents(page, function (component) {
            if (component.events) {
                lodash_1.forEach(component.events, function (actions, name) {
                    events[name] = actions.concat(events[name] || []);
                });
            }
            else if (component.type == 'link') {
                if (Array.isArray(component.parameters)) {
                    parameters[component.path] = component.parameters.map(function (parameter) { return parameter.name; });
                }
            }
        }, true);
        traverse(events, callback);
    });
    return parameters;
}
function allComponents(application, page, properties, options, dataSources) {
    var components = [];
    var types = {};
    function collect(component) {
        var _a = component.components, children = _a === void 0 ? [] : _a, _b = component.template, template = _b === void 0 ? [] : _b, _c = component.editTemplate, editTemplate = _c === void 0 ? [] : _c, _d = component.headerTemplate, headerTemplate = _d === void 0 ? [] : _d, _e = component.footerTemplate, footerTemplate = _e === void 0 ? [] : _e, _f = component.filterTemplate, filterTemplate = _f === void 0 ? [] : _f;
        components.push(component);
        children.forEach(collect);
        if (Array.isArray(template)) {
            template.forEach(collect);
        }
        if (Array.isArray(editTemplate)) {
            editTemplate.forEach(collect);
        }
        if (Array.isArray(headerTemplate)) {
            headerTemplate.forEach(collect);
        }
        if (Array.isArray(footerTemplate)) {
            footerTemplate.forEach(collect);
        }
        if (Array.isArray(filterTemplate)) {
            filterTemplate.forEach(collect);
        }
    }
    page.components.forEach(function (component) {
        var prepared = Component_1.prepareBlazorComponent(dataSources, application, properties, Object.assign({ root: true }, component), options, function (component) {
            var componentsOfType = types[component.type] || 0;
            componentsOfType++;
            types[component.type] = componentsOfType;
            return componentsOfType;
        });
        collect(prepared);
    });
    return components;
}
function traverseComponents(parent, callback, includeTemplateComponents) {
    if (includeTemplateComponents === void 0) { includeTemplateComponents = false; }
    var _a = parent.components, components = _a === void 0 ? [] : _a, _b = parent.template, template = _b === void 0 ? [] : _b;
    components.concat(template).forEach(function (component) {
        callback(component);
        Object.keys(component).forEach(function (key) {
            var value = component[key];
            if (value != null && (includeTemplateComponents || key != 'components')) {
                if (Array.isArray(value)) {
                    value.forEach(function (i) { return traverseComponents(i, callback); });
                }
                else {
                    traverseComponents(value, callback);
                }
            }
        });
        traverseComponents(component, callback);
    });
}
exports.traverseComponents = traverseComponents;
function propertiesAndServices(page) {
    var properties = setterNames(page.events);
    var services = serviceNames(page.events);
    traverseComponents(page, function (component) {
        if (component.events) {
            properties.push.apply(properties, setterNames(component.events));
            services.push.apply(services, serviceNames(component.events));
        }
    });
    return {
        properties: lodash_1.uniq(properties),
        services: lodash_1.uniq(services)
    };
}
function writePage(path, application, page, dataSources, options, isLayout, ignore, parameters) {
    if (isLayout === void 0) { isLayout = false; }
    var _a = propertiesAndServices(page), services = _a.services, properties = _a.properties;
    if (application.security) {
        services.push('Security');
    }
    var components = allComponents(application, page, properties, options, dataSources);
    var events = Object.keys(page.events || {}).map(function (name) {
        return {
            name: name,
            value: name,
            actions: page.events[name]
        };
    });
    var pageName = page.name;
    var access = page.access;
    if (!access) {
        access = [];
    }
    else if (!Array.isArray(access)) {
        access = [access];
    }
    var data = {
        isLayout: isLayout,
        name: pageName,
        layout: page.layout,
        access: access,
        events: events,
        dataSources: application.security
            ? dataSources.concat(DataSource_1.swaggerToDataSource(securityDataSource_1.securityDataSource(), application.https))
            : dataSources,
        properties: properties,
        security: application.security,
        services: services,
        members: properties.concat(services.map(env.variable)),
        componentTypes: lodash_1.uniq(components
            .filter(function (component) { return component.name; })
            .map(function (component) { return component.type; })).filter(env.isAngularComponent),
        components: components.filter(function (component) { return component.root === true; }),
        allComponents: components,
        dialogs: dialogs(page),
        application: application,
        options: options,
        upperFirst: lodash_1.upperFirst,
        camelCase: lodash_1.camelCase,
        env: env,
        parameters: parameters ? parameters[env.file(pageName)] : [],
        traverseComponents: traverseComponents,
        console: console
    };
    var filename = env.pascalCase(pageName);
    var templateName = isLayout ? 'layout' : 'page';
    var pageResources = [];
    if (application.localization &&
        application.localization.cultures.length > 1) {
        application.localization.cultures.map(function (c) {
            var targetPath = path_1.join(path, filename + "." + c.value + ".resx");
            if (ignore(targetPath)) {
                return;
            }
            // Always overwrite default culture resx.
            if (application.localization.defaultCulture &&
                application.localization.defaultCulture.value == c.value) {
                return renderTemplate_1.renderTemplate("page.resx.ejs", data).then(function (xml) {
                    return fs_1.writeFile(targetPath, xml);
                });
            }
            return fs_1.fileExists(targetPath)
                .then(function (exists) {
                if (exists) {
                    return fs_1.readFile(targetPath);
                }
                else {
                    return '';
                }
            })
                .then(function (targetXML) {
                return renderTemplate_1.renderTemplate("page.resx.ejs", data).then(function (sourceXML) { return merge_project_1.mergeResx(sourceXML, targetXML); });
            })
                .then(function (xml) { return fs_1.writeFile(targetPath, xml); });
        });
    }
    return Promise.all(pageResources.concat([
        writeTemplate(path_1.join(path, filename + ".razor.designer.cs"), templateName + ".razor.cs.ejs", data, ignore),
        writeTemplateOnce(path_1.join(path, filename + ".razor.cs"), templateName + "-partial.razor.cs.ejs", data, ignore),
        writeTemplate(path_1.join(path, filename + ".razor"), templateName + ".razor.ejs", data, ignore)
    ]));
}
function writeTemplate(path, template, data, ignore) {
    if (ignore(path)) {
        return;
    }
    return renderTemplate_1.renderTemplate(template, data).then(function (output) {
        return updateFile(path, output);
    });
}
function writeTemplateUnlessContains(application, path, template, value, data, ignore) {
    path = getPathByLanguage(application, path);
    return fs_1.fileExists(path)
        .then(function (exists) {
        if (exists) {
            // File exists - check if it contains the required value and overwrite otherwise.
            return fs_1.readFile(path).then(function (contents) { return contents.indexOf(value) < 0; });
        }
        else {
            // File does not exist - create it.
            return true;
        }
    })
        .then(function (write) {
        if (write) {
            return writeTemplate(path, template, data, ignore);
        }
    });
}
function writeTemplateOnce(path, template, data, ignore) {
    return fs_1.fileExists(path).then(function (exists) {
        if (!exists) {
            return writeTemplate(path, template, data, ignore);
        }
    });
}
function writeFileOnce(path, data, ignore, options) {
    if (ignore(path)) {
        return;
    }
    return fs_1.fileExists(path).then(function (exists) {
        if (!exists) {
            return fs_1.writeFile(path, data, options);
        }
    });
}
//# sourceMappingURL=index.js.map